#include <iostream>
#include<vector>
#include<queue>
using namespace std;

bool pointAvv[100000];
int flightsRemaining[100000];
int N,M,L;


int CheckPoint(vector<int>* conections,vector<int>* conectionType,int cur)
{
    if(cur == N-1)return 1;
    pointAvv[cur] = true;
    int MINLen = INT_MAX;

    for(int i = 0; i < conections[cur].size(); i++)
    {
        if(pointAvv[conections[cur][i]]||(conectionType[cur][i] != 1&&conectionType[cur][i] != 2))continue;
        if(conectionType[cur][i] == 2 && flightsRemaining[cur] == 0)continue;

        if(conectionType[cur][i] == 2)
        {
            flightsRemaining[conections[cur][i]] = flightsRemaining[cur]-1;
        }
        else flightsRemaining[conections[cur][i]] = flightsRemaining[cur];

        int curMin = CheckPoint(conections,conectionType,conections[cur][i]);

        if(curMin<MINLen)MINLen = curMin;
    }

    pointAvv[cur] = false;
    if(MINLen == INT_MAX)return INT_MAX;
    return MINLen + 1;
}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>N>>M>>L;

    vector<int> conections[M];
    vector<int> conectionType[M];

    for(int i = 0; i < M; i++)
    {
        int a,b,type;
        cin>>a>>b>>type;

        conectionType[a-1].push_back(type);
        conectionType[b-1].push_back(type);

        conections[a-1].push_back(b-1);
        conections[b-1].push_back(a-1);
    }

    flightsRemaining[0] = L;
    int otg = CheckPoint(conections,conectionType,0);

    if(otg == INT_MAX)
    {
        cout<<-1;
        return 0;
    }
    cout<<otg-1;
    return 0;
}
