#include<iostream>
#include<vector>
#include <climits>
#include "segment.h"
using namespace std;

int undevidable[] = {2,3,5,7,11,13,17,19,23,27,29};

int FindNOD(vector<int> A, int start, int length)
{
    vector<int> allFound;
    bool valuable[100000];
    int otg = A[start];

    bool found = true;
    int temp = A[start];
    while(found)
    {
        found = false;
        for(int i = 0; i<11;i++)
        {
            if(temp%undevidable[i] == 0)
            {
                temp/=undevidable[i];

                allFound.push_back(undevidable[i]);
                found = true;

                valuable[allFound.size()-1] = true;
                break;
            }
        }
    }

    for(int i = start+1; i<=start+length; i++)
    {
        int cur = A[i];
        for(int j = 0; j<allFound.size();j++)
        {
            if(valuable[j]&&cur%allFound[j] != 0)
            {
                valuable[j] = false;
                otg/=allFound[j];
            }
            else if(valuable[j]&&cur%allFound[j] == 0)
            {
                cur/=allFound[j];
            }
        }
    }

    return otg;
}

long long max_segment(vector<int> A)
{
    long long best = INT_MIN;

    for(int i = 0; i<A.size();i++)
    {
        for(int j = i+1; j<A.size();j++)
        {
            int cur = (j-i+1)*FindNOD(A,i,j-i);
            if(cur>best)best = cur;
        }
    }

    return best;
}
