#include<iostream>
#include<vector>
#include <climits>
#include "segment.h"
using namespace std;

int undevidable[] = {2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499};

int FindNOD(vector<int> A, int start, int length)
{
    vector<int> allFound;
    bool valuable[100000];
    int otg = A[start];

    int temp = A[start];
    while(temp != 1)
    {
        for(int i = 0; i<11;i++)
        {
            if(temp%undevidable[i] == 0)
            {
                temp/=undevidable[i];

                allFound.push_back(undevidable[i]);

                valuable[allFound.size()-1] = true;
                break;
            }
        }
    }

    for(int i = start+1; i<=start+length; i++)
    {
        int cur = A[i];
        for(int j = 0; j<allFound.size();j++)
        {
            if(valuable[j]&&cur%allFound[j] != 0)
            {
                valuable[j] = false;
                otg/=allFound[j];
            }
            else if(valuable[j]&&cur%allFound[j] == 0)
            {
                cur/=allFound[j];
            }
        }
    }

    return otg;
}

long long max_segment(vector<int> A)
{
    long long best = INT_MIN;

    for(int i = 0; i<A.size();i++)
    {
        for(int j = i+1; j<A.size();j++)
        {
            int cur = (j-i+1)*FindNOD(A,i,j-i);
            if(cur>best)best = cur;
        }
    }

    return best;
}
