#include<bits/stdc++.h>
using namespace std;
const int inf = 1000000;
vector<vector<pair<int, int>> >gr;
vector<bool>visited;
vector<int>lengths;
vector<pair<int, int> >pl;
int lc = 700001;
int n, m, k;


void dijkstra(int v)
{
    priority_queue<vector<pair<int, int> >, pair<int, int>, greater<pair<int, int> > > pq;
    pq.push(gr[v]);
    int p;
    while(pq.size())
    {
       p = pq.top();
       pq.pop();
       for(auto i: gr[v])
       {
           if(!visited[i.first])
           {
               visited[i.first] = true;
               pq.push(i.first);

           }
       }
       if(i.second + lengths[p] < lengths[pq.top()])
                lengths[pq.top()] = i.second + lengths[v];

    }
}

int main()
{
    int a, b, t;
    ios::sync_with_stdio(false);
    cin.tie(0);
    int ans = -1;

    cin>>n>>m>>k;
    gr.resize(n);

    for(int i = 0; i < m; i++)
    {
        cin>>a>>b>>t;
        if(t == 1)
        {
            gr[a-1].push_back(make_pair(b-1, 1));
            gr[b-1].push_back(make_pair(a-1, 1));
        }


        if(t == 2)
        {
            pl.push_back(make_pair(a-1, b-1));
        }

    }


    visited.resize(n);
    for(auto i : visited)
            i = false;

    lengths.resize(n);
    lengths[0] = 0;
    for(int i = 1; i < n; i++)
            lengths[i] = inf;

    dijkstra(0);

    if(lengths[n-1] > 700000)
    {
        ans = -1;
    }
    else
    {
        ans = lengths[n-1];
    }

    for(int i = 0; i < pl.size(); i++)
    {
        gr[pl[i].first].push_back(pl[i].second);
        gr[pl[i].second].push_back(pl[i].first);

        for(auto i : visited)
            i = false;

        dijkstra(0);

        if(ans == -1 && lengths[n-1] < 700000) ans = lengths[n-1];
        ans = min(ans, lengths[n-1]);

        gr[pl[i].first].pop_back();
        gr[pl[i].second].pop_back();

    }

    cout<<ans<<endl;

    return 0;
}
