#include<set>
#include"segment.h"

long long gcd(int a, int b) {
	int c = 0;
	while (b != 0) {
		c = a % b;
		a = b;
		b = c;
	}
	return a;
}

long long max_segment(std::vector<int> A) {
	std::set<long long>values;
	int currentgcd = 0;
	for (int i = 1; i <= A.size(); i++) {
		values.insert(i);
	}
	for (int i = 0; i < A.size(); i++) {
		for (int r = i; r < A.size(); r++) {
			currentgcd = A[i];
			for (int l = i + 1; l <= r; l++) {
				currentgcd = gcd(currentgcd, A[l]);
				if (currentgcd == 1) {
					break;
				}
				values.insert(((l + 1) - (i + 1) + 1) * currentgcd);
			}
		}
	}
	const auto it = values.rbegin();
	return *it;
}