#include<vector>
#include<cmath>
#include"segment.h"

const int MAX_ELS = 2000000001;

long long gcd(int a, int b) {
	if (a < b) {
		std::swap(a, b);
	}
	int c = 0;
	while (b != 0) {
		c = a % b;
		a = b;
		b = c;
	}
	return a;
}

bool checkIfAllArePrime(const std::vector<int>& A, int& max) {
	int num = A[0];
	for (int i = 0; i < A.size(); i++) {
		for (int j = 2; j<int(std::sqrt(A[i])); i++) {
			if (A[i] % j == 0)
				return false;
		}
		if (num < A[0]) {
			num = A[0];
		}
	}
	return true;
}

long long max_segment(std::vector<int> A) {
	//std::set<long long>values;
	/*int min = 0, max = 0;
	if (checkIfAllAreEven(A, max, min)) {
		long long res = maxStepOfTwoRes(A, max, min);
		return res;
	}*/
	int size = A.size();
	int max = 0;
	if (checkIfAllArePrime(A, max)) {
		int result = A.size() > max ? A.size() : max;
		return result;
	}
	int currentgcd = 0;
	long long result = size;
	/*for (int i = 1; i <= A.size(); i++) {
		values.insert(i);
	}*/
	long long val = 0;
	bool shouldBreak = false;
	for (int i = 0; i < size; i++) {
		shouldBreak = false;
		for (int r = i; r < size; r++) {
			currentgcd = A[i];
			if (result < A[i]) {
				result = A[i];
			}
			for (int l = i + 1; l <= r; l++) {
				currentgcd = gcd(currentgcd, A[l]);
				if (currentgcd == 1) {
					shouldBreak = true;
					break;
				}
				/*values.insert(((l + 1) - (i + 1) + 1) * currentgcd);*/
				val = ((l + 1) - (i + 1) + 1) * currentgcd;
				if (result < val) {
					result = val;
				}
			}
			if (shouldBreak)
				break;
		}
	}
	//const auto it = values.rbegin();
	return result;
}