#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n, m, k;
vector<int> gr[200005], gr2[200005];
int dist[200005][3];

queue<pair<int, int> > qu;

void bfs()
{
    for(int i=1; i<=n; i++)
    {
        dist[i][0]=dist[i][1]=dist[i][2]=1e9;
    }
    dist[1][0]=dist[1][1]=dist[1][2]=0;
    qu.push({1, 0});
    while(!qu.empty())
    {
        int tv=qu.front().first, br=qu.front().second;

        qu.pop();
        int brs1=gr[tv].size();
        int brs2=gr2[tv].size();
        for(int i=0; i<brs1; i++)
        {
            int nv=gr[tv][i];
            if(dist[nv][br]>dist[tv][br]+1)
            {
                dist[nv][br]=dist[tv][br]+1;
                qu.push({nv, br});
            }
        }
        if(br>=2) continue;
        for(int i=0; i<brs2; i++)
        {
            int nv=gr2[tv][i];
            if(dist[nv][br+1]>dist[tv][br]+1)
            {
                dist[nv][br+1]=dist[tv][br]+1;
                qu.push({nv, br+1});
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>k;
    for(int i=0; i<m; i++)
    {
        int u, v, ty;
        cin>>u>>v>>ty;
        if(ty==1)
        {
            gr[u].push_back(v);
            gr[v].push_back(u);
        }
        else
        {
            gr2[u].push_back(v);
            gr2[v].push_back(u);
        }
    }
    bfs();
    int otg=min(dist[n][0], dist[n][1]);
    if(k==2) otg=min(otg, dist[n][2]);
    if(otg==1e9) cout<<-1<<endl;
    else cout<<otg<<endl;
    return 0;
}
