#include <bits/stdc++.h>
#define MAXI 500005
#include "segment.h"
using namespace std;
int segm_tree[MAXI*4];
vector<int> a;
void build(int node, int L, int R)
{
    if(L == R)
    {
        segm_tree[node] = a[L-1];
        return;
    }

    int mid = (L+R)/2;
    build(node*2, L, mid);
    build(node*2+1, mid+1, R);
    segm_tree[node] = __gcd(segm_tree[node*2], segm_tree[node*2+1]);
}

int query(int node, int L, int R, int l, int r)
{
    if(L > r || R < l) return -1;
    if(L >= l && R <= r) return segm_tree[node];
    int mid = (L+R)/2;
    int s1 = query(node*2, L, mid, l, r);
    int s2 = query(node*2+1, mid+1, R, l, r);
    if(s1 == -1) return s2;
    if(s2 == -1) return s1;
    return __gcd(s1, s2);
}

long long max_segment(std::vector<int> A)
{
    int n = A.size();


    for(int i = 0; i < n; i ++)
    {
        int tek = A[i];
        a.push_back(tek);
    }
    build(1, 1, n);
    int maxi = -1;
    for(int k = 1; k <= n; k ++)
    {
        for(int j = k; j <= n; j ++)
        {
            int temp = (j - k + 1)*query(1, 1, n, k, j);
            if(temp > maxi) maxi = temp;
        }
    }
    return maxi;
}
/*
7
6 5 10 15 2 4 8
*/
