#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=2e5+5;
const int INF=1e9+5;

int n,m,k;
vector<int> adj[3*MAXN];
bool used[3*MAXN];
int dist[3*MAXN];

void bfs(int v)
{
    for(int i=1;i<=3*n;i++) dist[i]=INF;
    dist[v]=0;
    memset(used,0,sizeof(used));
    used[v]=1;
    queue<int> q;
    q.push(v);
    while(!q.empty())
    {
        v=q.front();
        q.pop();
        for(int i=0;i<adj[v].size();i++)
        {
            if(!used[adj[v][i]])
            {
                used[adj[v][i]]=1;
                dist[adj[v][i]]=dist[v]+1;
                q.push(adj[v][i]);
            }
        }
    }
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m>>k;
for(int i=0;i<m;i++)
{
    int u,v,t;
    cin>>u>>v>>t;
    if(t==1)
    {
        adj[u].push_back(v);
        adj[v].push_back(u);
        adj[u+n].push_back(v+n);
        adj[v+n].push_back(u+n);
        adj[u+2*n].push_back(v+2*n);
        adj[v+2*n].push_back(u+2*n);
    }
    else
    {
        adj[u].push_back(v+n);
        adj[v].push_back(u+n);
        adj[u+n].push_back(v+2*n);
        adj[v+n].push_back(u+2*n);
    }
}

bfs(1);

int ans=min(dist[n], dist[2*n]);
if(k>=2) ans=min(ans,dist[3*n]);

if(ans<INF) cout<<ans<<endl;
else cout<<-1<<endl;

return 0;
}
