#include<bits/stdc++.h>

#define MAXN 200002
#define INF 1e9

using namespace std;

int n, m, k, comp, c, distB[MAXN], distE[MAXN];
vector<int> M[MAXN];
vector<int> M2[MAXN];
bool vis[MAXN];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m>>k;
    for(int i = 0; i < m; i ++)
    {
        int a, b, t;
        cin>>a>>b>>t;
        if(t == 1)
        {
            M[a].push_back(b);
            M[b].push_back(a);
        }
        else
        {
            M2[a].push_back(b);
            M2[b].push_back(a);
        }
    }
}
void dijkstra(int v, int dist[])
{
    priority_queue<pair<int, int> > q;
    dist[v] = 0;
    q.push({0, v});
    memset(vis, 0, n + 1);
    //vis[v] = 1;
    while(q.size())
    {
        int u = q.top().second;
        q.pop();
        if(vis[u]) continue;
        vis[u] = 1;
        for(auto to : M[u])
        {
            if(!vis[to] && dist[to] > dist[u] + 1)
            {
                dist[to] = dist[u] + 1;
                q.push({-dist[to], to});
            }
        }
    }
}
void init()
{
    for(int i = 1; i <= n; i ++)
    {
        distB[i] = distE[i] = INF;
    }
}
void solve()
{
    int ans = distB[n];
    for(int i = 1; i <= n; i ++)
    {
        for(auto to : M2[i])
        {
            if(ans > distB[i] + 1 + distE[to])
            {
                ans = distB[i] + 1 + distE[to];
            }
        }
    }
    if(ans == INF) cout<<-1<<endl;
    else cout<<ans<<endl;
}
int main()
{
    read();
    init();
    dijkstra(1, distB);
    dijkstra(n, distE);
    solve();
    /*(int i = 1; i <= n; i ++)
    {
        cout<<i<<": "<<distB[i]<<" "<<distE[i]<<endl;
    }*/
    return 0;
}
