#include<bits/stdc++.h>
#include "segment.h"

#define MAXN 3000003

using namespace std;

vector<int> arr;

long long gcd(long long a, long long b)
{
    if(a == -1) return b;
    if(b == -1) return a;
    while(b)
    {
        long long r = b;
        b = a % b;
        a = r;
    }
    return a;
}

struct segTree
{
    long long tree[4 * MAXN];
    void build(int ind, int l, int r)
    {
        if(l == r)
        {
            tree[ind] = arr[l];
            return;
        }
        int mid = (l + r) / 2;
        build(ind * 2 + 1, l, mid);
        build(ind * 2 + 2, mid + 1, r);
        tree[ind] = gcd(tree[ind * 2 + 1], tree[ind * 2 + 2]);
    }
    long long query(int ind, int l, int r, int curL, int curR)
    {
        if(curL > r || curR < l) return -1;
        //cout<<l<<" "<<r<<"   "<<curL<<" "<<curR<<endl;
        if(curL >= l && curR <= r) return tree[ind];
        int mid = (curL + curR) / 2;
        int lQ = query(ind * 2 + 1, l, r, curL, mid);
        int rQ = query(ind * 2 + 2, l, r, mid + 1, curR);
        return gcd(lQ, rQ);
    }
}t;
int n;

/*void read()
{
    cin>>n;
    arr.resize(n);
    for(int i = 0; i < n; i ++)
    {
        cin>>arr[i];
    }
    t.build(0, 0, n - 1);
    /*cout<<t.query(0, 0, 6, 0, 6)<<endl;
    cout<<t.query(0, 0, 3, 0, 6)<<endl;
    cout<<t.query(0, 1, 3, 0, 6)<<endl;
}*/
long long max_segment(vector<long long> A)
{
    arr = A;
    t.build(0, 0, n - 1);
    long long ans = 0;
    for(int i = 0; i < n; i ++)
    {
        for(int j = i; j < n; j ++)
        {
            ans = max(ans, (j - i + 1) * t.query(0, i, j, 0, n - 1));
        }
    }
    return ans;
}
/*int main()
{
    read();
    cout<<max_segment()<<endl;
    return 0;
}*/
