#include<bits/stdc++.h>
#include "segment.h"

#define MAXN 3000003

using namespace std;

vector<int> arr;
int n;
long long st[MAXN][23];

long long gcd(long long a, long long b)
{
    if(a == -1) return b;
    if(b == -1) return a;
    while(b)
    {
        long long r = b;
        b = a % b;
        a = r;
    }
    return a;
}

void build()
{
    for(int i = 0; i < n; i ++) st[i][0] = arr[i];
    for(int i = 1; (1 << i) <= n; i ++)
    {
        for(int j = 0; j + (1 << i) <= n; j ++)
        {
            st[j][i] = gcd(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        }
    }
}
long long pw(long long p)
{
    long long br = 0;
    while(p)
    {
        p /= 2;
        br ++;
    }
    return br - 1;
}
long long query(long long a, long long b)
{
    if(b < a) swap(a, b);
    long long sz = (b - a + 1);
    long long p = pw(sz);
    return gcd(st[a][p], st[b - (1 << p) + 1][p]);
}
long long max_segment(vector<int> A)
{
    /*cout<<pw(2)<<endl;
    cout<<pw(3)<<endl;
    cout<<pw(4)<<endl;
    cout<<pw(1)<<endl;
    cout<<pw(7)<<endl;*/
    n = A.size();
    for(long long i = 0; i < n; i ++)
    {
        arr.push_back(A[i]);
    }
    /*t.init();
    t.build(0, 0, n - 1);*/
    build();
    long long ans = 0;
    for(long long i = 0; i < n; i ++)
    {
        for(long long j = i; j < n; j ++)
        {
            ans = max(ans, (j - i + 1) * query(i, j));
        }
    }
    return ans;
}
