#include<bits/stdc++.h>
#include "segment.h"

#define MAXN 3000001

using namespace std;

int n;
int st[MAXN][22];
long long ans;

void build(vector<int> &arr)
{
    for(int i = 0; i < n; i ++) st[i][0] = i;
    for(int i = 1; (1 << i) <= n; i ++)
    {
        for(int j = 0; j + (1 << i) <= n; j ++)
        {
            if(arr[st[j][i - 1]] < arr[st[j + (1 << (i - 1))][i - 1]]) st[j][i] = st[j][i - 1];
            else st[j][i] = st[j + (1 << (i - 1))][i - 1];
        }
    }
}
int pw(int p)
{
    int br = 0;
    while(p)
    {
        p /= 2;
        br ++;
    }
    return br - 1;
}
int queryMIN(int a, int b, vector<int> &arr)
{
    if(b < a) swap(a, b);
    int p = pw(b - a + 1);
    if(arr[st[a][p]] < arr[st[b - (1 << p) + 1][p]]) return st[a][p];
    else return st[b - (1 << p) + 1][p];
}
long long solve(int l, int r, vector<int> &arr)
{
    if(r < l) return -1;
    if(l == r) return arr[l];
    int p = queryMIN(l, r, arr);
    //cout<<l<<" "<<r<<" "<<cur<<endl;
    return ans = max(ans, max((long long)(r - l + 1) * arr[p], max(solve(l, p - 1, arr), solve(p + 1, r, arr))));
}
long long max_segment(vector<int> arr)
{
    /*cout<<pw(2)<<endl;
    cout<<pw(3)<<endl;
    cout<<pw(4)<<endl;
    cout<<pw(1)<<endl;
    cout<<pw(7)<<endl;*/
    /*t.init();
    t.build(0, 0, n - 1);*/
    n = arr.size();
    build(arr);
    return solve(0, n - 1, arr);
}
