#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
long long const MAXN = 2 * 1e5 + 2;
long long n, m, k,a,b,t,cur;
vector<long long > buses[MAXN];
long long erasing[MAXN];
vector<pair<long long,long long>> planes;
long long ans[MAXN];
bool visited[MAXN];
void inputF()
{
    cin  >> m >> k;
    for(long long i = 0; i < m; i++)
    {
        cin >> a >> b >> t;
        if(t == 1)
        {
            buses[a].push_back(b);
            buses[b].push_back(a);
        }
        else
        {
            planes.push_back(make_pair(a,b));
        }
    }
    //cout << "Finished Input!" << endl;
}
long long calcF()
{
    long long curV = 0;
    for(long long i = 1; i <= n; i++)visited[i]=false;
    for(long long i = 1; i <= n; i++)ans[i]=0;
    queue<long long> q;
    q.push(1);
    visited[1]=true;
    while(q.empty()==false /*&& ans[n] == 0*/)
    {
        long long cur = q.front(),next;
        q.pop();
        if(ans[cur] == curV+1)curV++;
        for(long long i = 0; i < buses[cur].size() - erasing[cur]; i++)
        {
            next = buses[cur][i];
            if(visited[next])continue;
            visited[next] = true;
            ans[next] = curV + 1;
            q.push(next);
        }
    }
    /*
    cout << "///////////" << endl;
    cout << "Printing Buses" << endl;
    for(long long i = 1; i <= n; i++){
            cout << i << " ";
        for(long long j = 0; j < buses[i].size() - erasing[i]; j++){
            cout << buses[i][j] << " ";
        }
    cout << endl;
    }
    cout << endl;
    cout << "Printing results!" << endl;
    for(long long i = 1; i <= n; i++){
        cout << i <<" "<< ans[i] << endl;
    }
    cout << endl;
    */
    if(ans[n] == 0)return -1;
    else return ans[n];

}
// K = 1
long long bfsF()
{
    long long Psize = planes.size();
    if(Psize == 0)
    {
        return calcF();
    }
    long long mini = -1,x,y,val;
    //K = 0
    //cout << "K0" << val << endl;
    //cout << "Planes SIZE" << planes.size() << endl;
    //K = 1

    for(long long j = 0; j < Psize; j++)
    {
        x = planes[j].first;
        y = planes[j].second;
        buses[x].push_back(y);
        buses[y].push_back(x);
        val = calcF();
        //cout << "K1" << val << endl;
        if(val!=-1){
            if(mini == -1)mini = val;
            if(mini < val)mini = val;
        }

        //buses[x].erase(buses[y].end()-1,buses[y].end());
        //buses[y].erase(buses[x].end()-1,buses[x].end());
        erasing[x]++;
        erasing[y]++;
        //cout << mini << endl;
    }
    return mini;
}

long long numOfPlanes;
bool matrix[1002][1002];



void inputB()
{

    cin >> m >> k;
    for(long long i = 0; i < m; i++)
    {
        cin >> a >> b >> t;
        if(t == 1)
        {
            matrix[a][b] = true;
            matrix[b][a] = true;
        }
        else
        {
            planes.push_back(make_pair(a,b));
            numOfPlanes ++;
        }
    }
    //cout << "Finished Input!" << endl;
}
long long calcB()
{
    /*
    cout << "New Calc" << endl;
    cout << endl;
    for(long long i = 1; i <= n; i++){
        for(long long j = 1; j <= n;j++){
            cout << matrix[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    */
    for(long long i = 1; i <= n; i++)ans[i]=0;
    queue<long long> q;
    q.push(1);
    while(q.empty()==false && ans[n]==0){
        cur = q.front();
        q.pop();
        for(long long i = 2; i <= n; i++){
            if(matrix[cur][i]==true && ans[i]==0){

                ans[i]=ans[cur]+1;
                //cout << i << " " << ans[i] << endl;
                q.push(i);
            }
        }
    }
    if(ans[n]==0)return -1;
    else return ans[n];
}
// K = 1
long long bfsB()
{
    if(numOfPlanes == 0)
    {
        return calcB();
    }
    else
    {
        long long val,ans = calcB(),x,y;
        for(long long j = 0; j < numOfPlanes; j++)
        {
            x = planes[j].first;
            y = planes[j].second;
            matrix[x][y] = true;
            matrix[y][x] = true;
            val = calcB();
            //cout << "K1" << val << endl;
            //cout << val << endl;
            if(val!=-1){
                if(ans > val || ans == -1) ans = val;

            }
            //cout << "Answer After That" << " " << ans << endl;
            matrix[x][y] = false;
            matrix[y][x] = false;
        }
        return ans;
    }

}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >>n;
    if(n <= 1000){
        inputB();
        cout <<bfsB() << endl;
    }
    else{
    inputF();

    cout << bfsF()<< endl;
    }
    return 0;
}


