#include <bits/stdc++.h>

using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "   "

typedef long long ll;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;

std::vector< std::pair< int, int > > v[MAX_N];
bool viz[MAX_N];
int dist[MAX_N][4];

signed main (){

#ifndef LOCAL
    std::ios_base::sync_with_stdio( false ); std::cin.tie( NULL );
#endif // LOCAL

    int n, m, k;
    std::cin >> n >> m >> k;

    for( int i=0 ; i < m ; i++ ){
        int a, b, c;
        std::cin >> a >> b >> c;
        a--; b--; c--;

        v[a].push_back({ b, c });
        v[b].push_back({ a, c });
    }
    for( int i=0 ; i <= n ; i++ ){
        for( int j = 0 ; j <= k ; j ++ ){
            dist[i][j] = mod;
        }
    }

    std::queue< std::pair< int, int > > q;
    q.push({ 0, 0 });
    dist[0][0] = 0;
    bool oke = false;
    while( !q.empty() ){
        auto curr = q.front(); q.pop();

        if( curr.second > k ) continue;

        for( auto j : v[curr.first] ){
            if( j.second ){
                if( chkmin( dist[j.first][curr.second + 1], dist[curr.first][curr.second] + 1 ) )
                    q.push({ j.first, curr.second + 1 });
            }else{
                if( chkmin( dist[j.first][curr.second], dist[curr.first][curr.second] + 1 ) )
                    q.push({ j.first, curr.second });
            }
        }
    }

    int nas = mod;
    for( int i=0 ; i <= k ; i++ ) chkmin( nas, dist[n-1][i] );

    std::cout << ( nas != mod ? nas : -1 ) << endl;
    return 0;
}

/*
7 9 1

1 6 2
6 7 2
3 7 2

1 2 1
1 3 1
2 4 1
4 5 1
3 5 1
5 7 1

*/

    /*

    oooo pak kopon,
    dzan dzan
    -Abe Emra ti nqma li da se jeni6 ve4e
    vseka ve4er koponi, vseka ve4er razli4ni
    dokoga taka, ti nqma li da se jeni6 ve4e
    -Abe tatko, kak da se jenq, ti ne vijda6 li kakvo stava tuka?

    parvata rusa, mnogo se drusa
    vtorata 4erna, uj mi e verna
    ot tretata bqdam, tq pak me goni
    4etvartata ima golemi balkoni
    petata 4uvam, 4e di6a baloni
    6estata samo parite mi goni
    segmana stava, ot vsekade stava,
    mnogo me iska, maja i ne dava

    Ajde be moj, neka pravime svatba
    500 gosti piqni na bradva
    parata da svar6i, 4udo golqmo
    bqlata roklq zaspa mi napravo
    samo edin problem ni ostana,
    malko si malak ba6ta ti ne dava

    Iskam da se jenq, isjam ama drug pat,
    jivee mi se o6te, lqto 4uka 4uk 4uk
    dajte da gi po4nem, tiq botilki
    SIPVAIIIIII o o o o

    */
