#include<iostream>
#include "segment.h"
#include <bits/stdc++.h>

using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "   "

typedef long long ll;

const int MAX_N = 1e6 + 42;
const int mod = 1e9 + 7;

long long max_segment(std::vector<int> a){

    int n = (int)a.size();
    ll nas = n;
    for( int i=0 ; i < n ; i++ ){
        int currGcd = a[i];
        chkmax( nas, currGcd );
        for( int j=i+1 ; j < n ; j ++ ){
            currGcd = std::__gcd( currGcd, a[j] );
            chkmax( nas, currGcd * ( j - i + 1 ) );
            if( currGcd == 1 ) break;
        }
    }

    return nas;
}

int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	int N;
	std::cin >> N;
	std::vector<int> A(N);
	for(auto &x : A) std::cin >> x;
	std::cout << max_segment(A) << std::endl;
}
