#include<iostream>
#include "segment.h"
#include <bits/stdc++.h>

using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "   "

typedef long long ll;

const int MAX_N = 1e6 + 42;
const ll MAX_VAL = 2e9 + 42;
const int mod = 1e9 + 7;

std::unordered_map< ll, int > m;

long long max_segment(std::vector<int> a){

    ll n = (ll)a.size();
    ll nas = n;

    ll pw = 1;
    int st = 0;
    while( true ){
        if( pw > MAX_VAL ) break;
        m[pw] = st;
        pw <<= 1;
        st ++;
    }

    std::vector< ll > b( n );
    for( int i = 0 ; i < n ; i++ ){
        int curr = m[a[i]];
        b[i] = curr;
    }

    std::stack< std::pair< ll, ll > > S;
    std::vector< ll > c( n );
    for( int i=0 ; i < n ; i ++ ){
        while( !S.empty() and S.top().first > b[i] ){
            c[S.top().second] = i;
            S.pop();
        }
        S.push({ b[i], i });
    }

    while( !S.empty() ){
        c[S.top().second] = n-1;
        S.pop();
    }

    for( int i=0 ; i < n ; i++ ){
        cerr << out( i ) << out( b[i] ) << out( c[i] ) << endl;
    }

    for( int i=0 ; i < n ; i++ ){
        cerr << out( c[i] - i ) << out( a[i] ) << endl;
        chkmax( nas, (ll)( c[i] - i ) * a[i] );
    }

    return nas;
}