#include <bits/stdc++.h>

using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "   "

typedef long long ll;

const int MAX_N = 1e3 + 42;
const int mod = 1e9 + 7;

int col[MAX_N];
int numCol[MAX_N];
int vizCol[MAX_N];
int viz[MAX_N];

int MAX;
int currCol;
std::vector< int > v[MAX_N];
int t[MAX_N][MAX_N];

void dfs( int x ){
    //cerr << out( x ) << out( currCol ) << endl;
    viz[x] = true;
    col[x] = currCol;
    for( auto j : v[x] ){
        if( viz[j] || col[j] != -1 ) continue;
        viz[j] = true;
        //cerr << out( numCol[currCol] ) << " + " << out( t[x][j] ) << out( MAX ) << endl;
        if( numCol[currCol] + t[x][j] <= MAX ){
            //cerr << " vlqzoh " << out( j ) << endl;
            numCol[currCol] += t[x][j];
            dfs( j );
        }
    }
}

std::vector< std::pair< int, int > > edge;
int cnt[MAX_N];

void myShuffle( std::vector< int >& a ){
    for( int i=0 ; i < 100 ; i ++ ){
        int A = rand()%a.size();
        int B = rand()%a.size();
        std::swap( a[A], a[B]);
    }
}

signed main (){

#ifndef LOCAL
    std::ios_base::sync_with_stdio( false ); std::cin.tie( NULL );
#endif // LOCAL

    int T;
    std::cin >> T;
    while( T --> 0 ){

    int n, m, d, k;
    std::cin >> n >> m >> d >> k;

    MAX = d / k;

    cerr << out( MAX ) << endl;

    for( int i=0 ; i < m ; i++ ){
        int a, b;
        std::cin >> a >> b;
        a--; b--;

        edge.push_back({ a, b });

        v[a].push_back( b );
        v[b].push_back( a );

        t[a][b] ++;
        t[b][a] ++;
    }
    for( int i=0; i < n ; i ++ ) col[i] = vizCol[i]  = -1;
    for( int i=0 ; i < k ; i++ ) numCol[i] = 0;

    std::vector< int > ind( n );
    std::iota( ind.begin(), ind.end(), 0 );
    srand( 420 );

    bool oke = true;
    while( oke ){

        for( int i=0 ; i < n ; i++ ) col[i] = rand() % k;

        oke = false;
        for( auto j : edge ){
            if( col[j.first] == col[j.second] ) cnt[col[j.first]]++;
            if( cnt[col[j.first]] > MAX ){
                oke = true;
                int A = rand() % ind.size();
                //std::swap( ind[0], ind[A] );
                //random_shuffle( ind.begin(), ind.end() );

            }
        }
        for( int i=0 ; i <= k ; i++ ) cnt[i] = 0;
    }

    for( int i=0 ; i < n ; i++ ) std::cout << col[i] + 1 << " ";
    cerr << endl;

        for( int i=0 ; i < n ; i++ ){
            for( int j=0 ; j < n ; j++ ) t[i][j] = 0;
            v[i].clear();
        }
    }

    return 0;
}
