#include<iostream>
#include<bits/stdc++.h>
using namespace std;

const int MAX_M = 600000;
pair <int, int> connect[MAX_M];
short transp[MAX_M];
int ans = MAX_M;
bool goneThrough[MAX_M];

void clean(int m){
    for(int i = 0; i < m; i++){
        goneThrough[i] = false;
    }
}

int pathway(int start, bool usedPlane, int way, int n, int m){
    if(start == n){
        clean(m);
        return way;
    }
    for(int i = 0; i < m; i++){
        if(start == connect[i].first){
            if((usedPlane && transp[i] == 2) || goneThrough[i]){
                continue;
            }else if(!usedPlane && transp[i] == 2){
                goneThrough[connect[i].first] = true;
                ans = min(ans, pathway(connect[i].second, true, way + 1, n, m));
            }else{
                goneThrough[connect[i].first] = true;
                ans = min(ans, pathway(connect[i].second, false, way + 1, n, m));
            }
        }
    }
    if(ans == MAX_M){
        ans = -1;
    }
    return MAX_M;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k, buf;
    cin >> n >> m >>k;
    for(int i = 0; i < m; i++){
        cin >> connect[i].first >> connect[i].second >> transp[i];
    }
    buf = pathway(1, false, 0, n, m);
    cout << ans;
    return 0;
}
