#include <bits/stdc++.h>
using namespace std;
int n, m, k;
const int MAX_N = 200000;
vector< pair <int, int> > graph[MAX_N];

bool visited[MAX_N];
int usedAirplanes;
int currLength;
int bestPath = 10000000;

void dfs(int currV, bool byAirplane)
{
    visited[currV] = true;
    if(currV == n - 1)
    {
        if(usedAirplanes <= k)
        {
            bestPath = min(bestPath, currLength);
        }
    }
    else
    {
        for(int i = 0; i < graph[currV].size(); i++)
        {
            if(!visited[graph[currV][i].first])
            {
                if(graph[currV][i].second == 1)
                {
                    currLength++;
                    dfs(graph[currV][i].first, false);
                }
                else
                {
                    if(usedAirplanes + 1 <= k)
                    {
                        currLength++;
                        usedAirplanes++;
                        dfs(graph[currV][i].first, true);
                    }
                }
            }
        }
    }

    visited[currV] = false;
    currLength--;
    if(byAirplane)
    {
        usedAirplanes--;
    }

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> k;
    for(int i = 0; i < m; i++)
    {
        int a, b, t;
        cin >> a >> b >> t;
        a--;
        b--;
        pair<int, int> p;
        p.first = b;
        p.second = t;
        graph[a].push_back(p);

        p.first = a;
        p.second = t;
        graph[b].push_back(p);

    }
    dfs(0, false);
    if(bestPath == 10000000)
    {
        cout << -1;
    }
    else
    {
        cout << bestPath;
    }

    return 0;
}
