#include "segment.h"
#include <bits/stdc++.h>
#include <numeric>
#include <cmath>
using namespace std;

bool isAPowerOf2(int x)
{
    while(x > 1)
    {
        if(x % 2 == 1)
        {
            return false;
        }
        x /= 2;
    }
    return true;
}

long long max_segment(std::vector<int> A)
{
    int n = A.size();
    bool specialCase = true;
    for(int i = 0; i < n; i++)
    {
        if(!isAPowerOf2(A[i]))
        {
            specialCase = false;
            break;
        }
    }
    if(specialCase)
    {
        long long bestRes = 0;
        for(int i = 0; i < n; i++)
        {
            int l = 0, r = n - 1;
            for(int j = i + 1; j < n; j++)
            {
                if(A[j] < A[i])
                {
                    r = j - 1;
                    break;
                }
            }
            for(int j = i - 1; j >= 0; j--)
            {
                if(A[j] < A[i])
                {
                    l = j + 1;
                    break;
                }
            }
            bestRes = max(bestRes, (long long)((r - l + 1) * A[i]));
        }
        return bestRes;
    }
    if(n > 70000)
    {
        long long bestRes = 0;
        int currLen = 1;
        for(int i = 1; i < n; i++)
        {
            if(A[i] == A[i - 1])
            {
                currLen++;
            }
            else
            {
                bestRes = max(bestRes, (long long)currLen * A[i - 1]);
                currLen = 1;
            }
        }
        bestRes = max(bestRes, (long long)currLen * A[n - 1]);
        return max((long long)n, bestRes);
    }
    long long maxres = 0;
    for(int l = 0; l < n; l++)
    {
        long long currGcd = A[l];
        for(int r = l; r < n; r++)
        {
            /*for(int i = l + 1; i <= r; i++)
            {
                currGcd = __gcd(currGcd, (long long)A[i]);
            }*/
            currGcd = __gcd(currGcd, (long long)A[r]);
            if((n - 1 - l + 1) * currGcd <= maxres)
            {
                break;
            }
            maxres = max(maxres, (r - l + 1) * currGcd);
        }
    }
    return maxres;
}
