#include <iostream>
#include <vector>
#include <stack>
#include "segment.h"
using namespace std;
const long long INF = 2 * 1e9;
const int MAXN = 3 * 1e6 + 1;
int rig[MAXN], lef[MAXN];
long long max_segment(vector<int> A) {
    int n = A.size();

    long long maxx = n;
    stack<int> dep;
    dep.push(0);
    for (int i = 1; i < n; i++) {
        while (!dep.empty() && A[i] < A[dep.top()]) {
            rig[dep.top()] = i;
            dep.pop();
        }
        dep.push(i);
    }
    while (!dep.empty()) {
        rig[dep.top()] = n - 1;
        dep.pop();
    }

    dep.push(n - 1);
    for (int i = n - 2; i >= 0; i--) {
        while (!dep.empty() && A[i] < A[dep.top()]) {
            lef[dep.top()] = i;
            dep.pop();
        }
        dep.push(i);
    }
    while (!dep.empty()) {
        lef[dep.top()] = 0;
        dep.pop();
    }

    for (int i = 0; i < n; i++) {
        long long len = rig[i] - lef[i] + 1;
        maxx = max(maxx, A[i] * len);
    }
    return maxx;
}
//int main() {
//
//    return 0;
//}

