#include<iostream>
#include<algorithm>
#include<vector>
#include "segment.h"
using namespace std;
int gcd[2000005];
vector<int> a(500005);
void build(int node,int l,int r)
{
    if(l==r)
    {
        gcd[node]=a[l];
        return;
    }
    int mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);

    gcd[node]=__gcd(gcd[2*node],gcd[2*node+1]);
}
int getgcd(int node,int l,int r,int le,int ri)
{
    if(l>=le && r<=ri)
        return gcd[node];

    if(l>ri || r<le)
        return -1;

    int mid=(l+r)/2;

    int a=getgcd(2*node,l,mid,le,ri), b=getgcd(2*node+1,mid+1,r,le,ri);

    if(a==-1) return b;
    if(b==-1) return a;

    return __gcd(a,b);
}
long long max_segment(std::vector<int> A)
{
    a[0]=0;
    int n=A.size();
    for(int i=0;i<n;i++)
    {
        a[i+1]=A[i];
    }
    build(1,1,n);

    long long rez=n;

    int lr,next,rr,r;
    for(int l=1;l<=n;l++)
    {
        next=l;
        while(next<=n)
        {
           int init=getgcd(1,1,n,l,next),now;
           lr=next;rr=n;
           while(lr<=rr)
           {
               r=(lr+rr)/2;
               now=getgcd(1,1,n,l,r);

               if(now==init)
                lr=r+1;
               else
                rr=r-1;
           }

           rez=max(rez,(long long)init*(rr-l+1));
           next=rr+1;
        }

    }

    return rez;
}

