#include "segment.h"
#include <iostream>
#include <vector>
#include <stack>
using namespace std;
const int MAXN=3e6+10;
int x[MAXN], ri[MAXN];
stack <int> st;
int n;
int find_stepen(int x) {
    int res=0;
    while ((1ll<<res)<=x) res++;
    res--;
    return res;
}
long long max_segment(vector <int> a) {
    n=a.size();
    for (int i=0;i<n;i++) x[i]=find_stepen(a[i]);
    for (int i=n-1;i>=0;i--) {
        while (!st.empty() && x[st.top()]>=x[i]) st.pop();
        if (st.empty()) ri[i]=n;
        else ri[i]=st.top();
        st.push(i);
    }
    long long ans=0, cur, len;
    for (int i=0;i<n;i++) {
        int j=i;
        cur=a[i];
        while (j<n) {
            len=ri[j]-i;
            ans=max(ans,len*cur);
            j=ri[j];
            if (j==n) break;
            cur=a[j];
        }
    }
    return ans;
}
/*
int main () {
    cout << max_segment({2,2,1,4,4,8,2}) << endl;
    return 0;
}*/
