#include <iostream>
#include <vector>
#include <algorithm>
#define MAX_N 200005
using namespace std;

int n, m, k;
int a, b, t;
vector<vector<pair<int, int>>> paths;

int dist[3][MAX_N];

void solve()
{
    int td;
    fill_n (dist[0], MAX_N, MAX_N);
    fill_n (dist[1], MAX_N, MAX_N);
    fill_n (dist[2], MAX_N, MAX_N);
    vector<int> noplane[2];
    vector<int> plane[2];
    vector<int> tplane[2];

    noplane[1].push_back(1);

    for(int i=1; i<n; i++)
    {
        if(noplane[i%2].size()==0 && plane[i%2].size()==0 && tplane[i%2].size()==0)
        {
            break;
        }
        for(int j=0; j<noplane[i%2].size(); j++)
        {
            for(int f=0; f<paths[noplane[i%2][j]].size(); f++)
            {
                if(paths[noplane[i%2][j]][f].second==1)
                {
                    td=dist[0][noplane[i%2][j]]+1;
                    if(td<dist[0][paths[noplane[i%2][j]][f].first])
                    {
                        dist[0][paths[noplane[i%2][j]][f].first]=td;
                        noplane[(i+1)%2].push_back(paths[noplane[i%2][j]][f].first);
                    }
                }
                if(paths[noplane[i%2][j]][f].second==2)
                {
                    td=dist[0][noplane[i%2][j]]+1;
                    if(td<dist[1][paths[noplane[i%2][j]][f].first])
                    {
                        dist[1][paths[noplane[i%2][j]][f].first]=td;
                        plane[(i+1)%2].push_back(paths[noplane[i%2][j]][f].first);
                    }
                }
            }
        }


        for(int j=0; j<plane[i%2].size(); j++)
        {
            for(int f=0; f<paths[plane[i%2][j]].size(); f++)
            {
                if(paths[plane[i%2][j]][f].second==1)
                {
                    td=dist[1][plane[i%2][j]]+1;
                    if(td<dist[1][paths[plane[i%2][j]][f].first])
                    {
                        dist[1][paths[plane[i%2][j]][f].first]=td;
                        plane[(i+1)%2].push_back(paths[plane[i%2][j]][f].first);
                    }
                }
                if(paths[plane[i%2][j]][f].second==2 && k==2)
                {
                    td=dist[1][plane[i%2][j]]+1;
                    if(td<dist[2][paths[plane[i%2][j]][f].first])
                    {
                        dist[2][paths[plane[i%2][j]][f].first]=td;
                        tplane[(i+1)%2].push_back(paths[plane[i%2][j]][f].first);
                    }
                }
            }
        }
        if(k==2)
        {
            for(int j=0; j<noplane[i%2].size(); j++)
            {
                for(int f=0; f<paths[noplane[i%2][j]].size(); f++)
                {
                    if(paths[tplane[i%2][j]][f].second==1)
                    {
                        td=dist[2][tplane[i%2][j]]+1;
                        if(td<dist[2][paths[tplane[i%2][j]][f].first])
                        {
                            dist[2][paths[tplane[i%2][j]][f].first]=td;
                            tplane[(i+1)%2].push_back(paths[tplane[i%2][j]][f].first);
                        }
                    }
                }
            }
        }
        noplane[i%2].clear();
        plane[i%2].clear();
        tplane[i%2].clear();
    }

}

int main()
{
    cin >> n >> m >> k;

    paths.resize(n+1);

    for(int i=0; i<m; i++)
    {
        cin >> a >> b >> t;
        paths[a].push_back({b, t});
        paths[b].push_back({a, t});
    }

    int ans=min(dist[1][n], dist[0][n]);

    if(k==1)
    {
        cout << ans;
    }
    else
    {
        ans=min(ans, dist[2][n]);
        cout << ans;
    }



    return 0;
}
