#include <iostream>
#include "segment.h"
#define MAX_N 3000006
using namespace std;

long long table[33][2];
long long tpow[33];

void fill_tpow()
{
    tpow[0]=1;
    for(int i=1; i<33; i++)
    {
        tpow[i]=tpow[i-1]*2;
        //cout << tpow[i] << endl;
    }
}


long long max_segment(std::vector<int> A)
{
    fill_tpow();
    int j=0;
    int in;

    long long ans=0;

    while(tpow[j]<=(long long)A[0])
    {
        table[j][0]=tpow[j];
        ans=tpow[j];
        j++;
    }
    for(int k=j; k<33; k++)
    {
        table[k][0]=0;
    }

    for(int i=1; i<A.size(); i++)
    {
        j=0;
        //cout << A[i] << " ";
        in=i%2;
        while(j<33 && tpow[j]<=(long long)A[i])
        {
            //cout << tpow[j] << " ";
            table[j][in]=table[j][(in+1)%2]+tpow[j];
            //cout << table[j][i] << " ";
            if(table[j][in]>ans)
            {
                ans=table[j][in];
            }
            j++;
        }
        for(int k=j; k<33; k++)
        {
            table[k][0]=0;
        }

        //cout << endl;
    }

    /*for(int j=0; j<20; j++)
    {
        for(int i=0; i<A.size(); i++)
        {
            cout << table[j][i] << " ";
        }
        cout << endl;
    }*/

    return ans;
}
