// set path=%path%;C:\Program Files\CodeBlocks\MinGW\bin
#include <bits/stdc++.h>

#include "segment.h"

int64_t nod(int64_t a, int64_t b) {
	if (b == 0) return a;
	return nod(b, a % b);
}

long long max_segment_n2(std::vector<int> a) {
	int64_t n = a.size();
	int64_t otg = 0;
	for (int64_t l = 0; l < n; l += 1) {
		int64_t seg_nod = a[l];
		for (int64_t d = l; d < n; d += 1) {
			seg_nod = nod(seg_nod, a[d]);
			otg = std::max(otg, seg_nod * (d - l + 1));
		}
	}
	return otg;
}

long long max_segment_prosti(std::vector<int> a) {
	int64_t n = a.size();
	int64_t otg = 0;
	for (int64_t i = 0; i < n; i += 1) {
		otg = std::max(otg, a[i]);
	}
	return otg;
}

long long max_segment(std::vector<int> a) {
	return max_segment_prosti(a);
}

#ifndef EVAL
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	
	int N;
	std::cin >> N;
	std::vector<int> A(N);
	for(auto &x : A) std::cin >> x;
	std::cout << max_segment(A) << std::endl;
	
	return 0;
}
#endif