// set path=%path%;C:\Program Files\CodeBlocks\MinGW\bin
#include <bits/stdc++.h>

#include "segment.h"

int64_t nod(int64_t a, int64_t b) {
	if (b == 0) return a;
	return nod(b, a % b);
}

long long max_segment_n2(std::vector<int> a) {
	int64_t n = a.size();
	int64_t otg = 0;
	for (int64_t l = 0; l < n; l += 1) {
		int64_t seg_nod = a[l];
		for (int64_t d = l; d < n; d += 1) {
			seg_nod = nod(seg_nod, a[d]);
			otg = std::max(otg, seg_nod * (d - l + 1));
		}
	}
	return otg;
}

long long max_segment_prosti(std::vector<int> a) {
	int64_t n = a.size();
	int64_t otg = n;

	int64_t dwljina = 1;
	
	for (int64_t i = 1; i < n; i += 1) {
		if (a[i] == a[i-1]) {
			dwljina += 1;
		} else {
			otg = std::max(otg, dwljina * a[i-1]);
			dwljina = 1;
		}
	}
	otg = std::max(otg, dwljina * a[n-1]);
	return otg;
}

long long max_segment_2x(std::vector<int> a) {
	int64_t n = a.size();

	int64_t dwljina[31] = {};
	
	int64_t otg = 0;
	
	for (int64_t i = 0; i < n; i += 1) {
		for (int64_t y = 0; y < 31; y += 1) {
			if ((1 << y) <= a[i]) dwljina[y] += 1;
			else                  dwljina[y]  = 0;
			
			otg = std::max(otg, (1 << y) * dwljina[y]);
		}
	}
	
	return otg;
}

long long max_segment(std::vector<int> a) {
	return max_segment_2x(a);
}

#ifndef EVAL
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	
	int N;
	std::cin >> N;
	std::vector<int> A(N);
	for(auto &x : A) std::cin >> x;
	std::cout << max_segment(A) << std::endl;
	
	return 0;
}
#endif