#include <bits/stdc++.h>


using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}


int gcd(int a, int b)
{
    if (a < b)
        swap(a, b);
    while(b != 0)
    {
        int p = b;
        b = a % b;
        a = p;
    }
    return a;
}

const int maxn = 3e6 + 10, maxlog = 23;
int n, a[maxn];
int dp[maxlog][maxn], lg[maxn];

void build_sparse_table()
{
    for (int i = 1; i <= n - 1; i ++)
    {
        lg[i] = lg[i / 2] + 1;
        dp[0][i] = gcd(a[i], a[i + 1]);
    }

    for (int j = 1; j < lg[n - 1]; j ++)
        for (int i = 1; i <= n - (1 << j); i ++)
    {
        dp[j][i] = gcd(dp[j - 1][i], dp[j - 1][i + (1 << (j - 1))]);
    }


}

int query(int l, int r)
{
    int len = lg[r - l + 1] - 1;
    return gcd(dp[len][l], dp[len][r - (1 << len) + 1]);
}

ll max_segment(vector < int > A)
{
    n = A.size();
    for (int i = 1; i <= n; i ++)
        a[i] = A[i - 1];

    build_sparse_table();

    ll ans = 0;
    for (int i = 1; i <= n; i ++)
        ans = max(ans, (ll)a[i]);

    /**for (int l = 1; l <= n; l ++)
    {
        for (int r = l + 1; r <= n; r ++)
        {
            ans = max(ans, (ll)(r - l + 1) * (ll)(query(l, r - 1)));
        }
    }*/

    for (int i = 1; i <= n; i ++)
    {
        int pivot = i, last = a[i];
        int lf = i + 1, rf = n;
        while(lf <= rf)
        {
            int mf = (lf + rf) / 2;
            if (query(i, mf - 1) != last)
                rf = mf - 1;
            else
                lf = mf + 1;
        }

        pivot = rf;
        ans = max(ans, (ll)(pivot - i + 1) * (ll)(last));
        //cout << "here " << (ll)(pivot - i + 1) * (ll)(last) << endl;
        //cout << i << " " << pivot << endl;

        while(pivot < n)
        {
            int nxt = gcd(a[pivot + 1], last);
            int l = pivot + 1, r = n;
            while(l <= r)
            {
                int m = (l + r) / 2;
                if (query(i, m - 1) == nxt)
                    l = m + 1;
                else
                    r = m - 1;
            }
            ans = max(ans, (ll)(l - i) * (ll)(nxt));
            last = nxt;
            pivot = l - 1;
        }

    }


    return ans;
}
