#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#define endl "\n"

//#define __LOCALTEST

#ifdef __LOCALTEST
using namespace std;
using namespace __gnu_cxx;
#else
using std::cin;
using std::cout;
using std::ios_base;
using std::vector;
using std::greater_equal;
using std::max_element;
#endif

bool isprime(int n)
{
    if(n == 1 || n == 2) return true;
    for(int d = 2; d <= sqrt(n); d++)
    {
        if(n % d == 0) return false;
    }
    return true;
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

long long max_segment(vector<int> A)
{
    speed();
    sort(A.begin(), A.end());
    int prev_pos = 0;
    int cnt1 = 0;
    int cnt_tmp = 0;
    int cnt_tmp2 = 0;

    for(int i = 0; i < A.size(); i++)
    {
        if(A[i] == 1) cnt_tmp++;
        if(A[i] % 2 == 0) cnt_tmp2++;
        if(isprime(A[i])) cnt1++;
    }
    if(cnt1 == A.size())
    {
        int s = 0;
        int mx = 0;
        cnt1 = 0;

        for(int i = 0; i < A.size(); i++)
        {
            if(A[i] > mx && A[i] != *max_element(A.begin(), A.end()))
            {
                mx = A[i];
            }
        }
        for(int i = 0; i < A.size(); i++)
        {
            if(A[i] == mx) cnt1++;
        }
        sort(A.begin(), A.end(), greater_equal<int>());
        for(int i = 1; i < cnt1+1; i++)
        {
            s += A[i];
        }
        return s;

    }
    else if(cnt_tmp + cnt_tmp2 == A.size())
    {
        int maxc = 0;
        for(int i = 0; i < A.size() - 1; i++)
        {
            if(A[i] + A[i + 1] > maxc)
                maxc = A[i] + A[i + 1];
        }
        return maxc;
    }

    return A[A.size() - 1];
}
