#include<bits/stdc++.h>
#include "segment.h"
#define endl '\n'
using namespace std;
const int maxn = 3e6 + 10;
int t[4*maxn];
int n;
long long ans = 0;

int gcd(int a, int b){
    if (a < b)swap(a, b);
    while (b){
        int temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

void make_tree(int i, int l, int r,const vector<int> &a){
    if (l == r){
        t[i] = a[l - 1];
        return;
    }
    int mid = (l + r) / 2;
    make_tree(i * 2, l, mid, a);
    make_tree(i * 2 + 1, mid + 1, r, a);
    t[i] = __gcd(t[i * 2],  t[i * 2 + 1]);
}

int query(int i, int l, int r, int ql, int qr){
    //cout << "query: " << i << " " << l << " " << r << endl;
    if (l == ql && r == qr)
        return t[i];
    int mid = (l + r) / 2;
    if (qr <= mid)
        return query(i * 2, l, mid, ql, qr);
    if (ql > mid)
        return query(i * 2 + 1, mid + 1, r, ql, qr);
    return __gcd(query(i * 2, l, mid, ql, mid),
               query(i * 2 + 1, mid + 1, r, mid + 1, qr));
}

void tree_sol(const vector<int> &a){
    make_tree(1, 1, n, a);
    //cout << "here3\n";
    long long one, two, rez;
    for (int i = 1; i <= n; ++i)
        for (int j = i; j <= n; ++j){
            one = j - i + 1;
            two = query(1, 1, n, i, j);
            rez = one * two;
            //cout << "In for: " << i << " " << j << " " << one << " " << two << " " << rez << endl;
            ans = (ans < rez)? rez: ans;
        }
}

void platform_sol(const vector<int> &a){
    long long cnt_el = 1, el = a[0], rez;
    for (int i = 1; i < n; ++i){
        if (el == a[i])
            cnt_el++;
        else{
            rez = cnt_el * el;
            ans = (rez > ans)? rez: ans;
            cnt_el = 1;
            el = a[i];
        }
    }
    rez = cnt_el * el;
    ans = (rez > ans)? rez: ans;
}

long long max_segment(vector<int> A){
    n = A.size();
    const vector<int> &a = A;
    if (n <= 500)
        tree_sol(a);
    else platform_sol(a);
    return ans;
}
/*
7
6 5 10 15 2 4 8

*/
