#include<iostream>
#include<vector>
#include <climits>
#include "segment.h"
using namespace std;

int undevidable[] = {2,3,5,7,11,13,17,19,23,27,29};

int FindNOD(vector<int> A, int start, int length)
{
    vector<int> allFound;
    bool valuable[100000];
    int otg = 1;

    bool found = true;
    int temp = A[0];
    while(found)
    {
        found = false;
        for(int i = 0; i<11;i++)
        {
            if(temp%undevidable[i] == 0)
            {
                temp/=undevidable[i];
                otg *= undevidable[i];

                allFound.push_back(undevidable[i]);
                found = true;

                valuable[allFound.size()-1] = true;
                break;
            }
        }
    }

    for(int i = 0; i<A.size(); i++)
    {
        for(int j = 0; j<allFound.size();j++)
        {
            if(valuable[i]&&A[i]%allFound[i] != 0)
            {
                valuable[i] = false;
                otg/=allFound[i];
            }
        }
    }

    return otg;
}

long long max_segment(vector<int> A)
{

    int pointer1 = 0;
    int pointer2 = 1;
    int best = INT_MIN;

    while(pointer1 != A.size())
    {
        int cur = (pointer2-pointer1+1)*FindNOD(A,pointer1,pointer2-pointer1);
        if(cur>best)
        {
            best = cur;
            pointer2++;
        }
        else if(cur<=best)
        {
            pointer1++;
        }
    }

    return best;
}
