#include <iostream>
#include <vector>
#include <map>

using namespace std;

void TravelToCities(vector<int>cities, int shortestRoute, int n, int k)
{
	int currentCity = 1;
	int traveledCities = 0;

	map<int, int>citiesAppeared;

	for (int i = 0; i < cities.size(); i += 3)
	{
		auto search = citiesAppeared.find(cities[i + 1]);
		if (search != citiesAppeared.end()) {
			citiesAppeared[cities[i + 1]]++;
		}
		else {
			citiesAppeared[cities[i + 1]] = 1;
		}
	}

	for (int j = 0; j < cities.size(); j+=3)
	{
		for (int i = 0; i < cities.size(); i += 3)
		{
			if (currentCity == n)
			{
				break;
			}

			if (cities[i] == currentCity)
			{
				if (cities[i + 2] == 2)
				{
					if (k != 0)
					{
						k--;
					}
					else
					{
						continue;
					}
				}

				traveledCities++;
				currentCity = cities[i + 1];
			}
			else
			{
				continue;
			}
		}
	}
}

int main()
{
	int n, m, k;
	cin >> n >> m >> k;

	vector<int>cities(m * 3);

	int length = m * 3;

	for (int i = 0; i < length; i += 3)
	{
		int a, b, t;
		cin >> a >> b >> t;

		cities[i] = a;
		cities[i + 1] = b;
		cities[i + 2] = t;
	}

	int currentCity = 1;
	int traveledCities = 0;

	for (int i = 0; i < length; i += 3)
	{
		if (currentCity == n)
		{
			break;
		}

		if (cities[i] == currentCity)
		{
			if (cities[i + 2] == 2)
			{
				if (k != 0)
				{
					k--;
				}
				else
				{
					continue;
				}
			}

			traveledCities++;
			currentCity = cities[i + 1];
		}
		else
		{
			continue;
		}
	}

	if (currentCity == n)
	{
		cout << traveledCities;
	}
	else
	{
		cout << -1;
	}
}

//5 5 1
//1 2 1
//2 4 1
//2 5 1
//3 5 2
//4 5 2
