#include<bits/stdc++.h>
using namespace std;

vector<vector<int > >adj;
vector<bool>visited;
vector<int>colour;
vector<vector<int>>cc;

void bfs(int v, int r, int k)
{
    int time = 0, color = 1;
    queue<int>q;
    visited[v] = true;
    q.push(v);
    colour[v] = 1;
    int c;
    //cout<<q.size()<<endl;
    while(q.size())
    {
        //cout<<"aaa"<<endl;
        c = q.front();

        q.pop();
        for(int i = 0; i < adj[c].size(); i++)
        {
            if(!visited[adj[c][i]])
            {
                //cout<<adj[c][i]<<endl;
                q.push(adj[c][i]);
                visited[adj[c][i]] = true;

                if(colour[adj[c][i]] == -1)
                {
                    for(int j = 1; j <= k; j++)
                    {
                        if(cc[c][j-1] < r)
                        {
                            colour[adj[c][i]] = j;
                            cc[c][j-1]++;
                            break;
                        }
                    }
                }
            }


        }
    }

}


int main()
{
    int t, n, m, d, k, a, b;
    cin>>t;
    for(int i = 0; i < t; i++)
    {
        cin>>n>>m>>d>>k;
        adj.resize(n);
        colour.resize(n, -1);
        cc.resize(n);
        for(int l = 0; l < n; l++)
        {
            cc[l].resize(k, 0);
        }

        visited.resize(n, false);
        int r = d/k;
        for(int j = 0; j < m; j++)
        {
            cin>>a>>b;
            adj[a-1].push_back((b-1));
            adj[b-1].push_back((a-1));
        }
        /*
        for(int j = 0; j < n; j++)
        {
            for(int k = 0; k < adj[j].size(); k++)
            {
                cout<<adj[j][k].first<<" "<<adj[j][k].second<<" | ";
            }
            cout<<endl;
        }*/

        bfs(0, r, k);

        for(int j = 0; j < n; j++)
        {
            cout<<colour[j]<<" ";
        }
        cout<<endl;
    }


}
