#include<vector>
#include"segment.h"

long long gcd(int a, int b) {
	if (a < b) {
		std::swap(a, b);
	}
	int c = 0;
	while (b != 0) {
		c = a % b;
		a = b;
		b = c;
	}
	return a;
}

bool checkIfAllAreEven(const std::vector<int>& A) {

	for (int i = 1; i < A.size();i++) {
		if (A[i] % 2 != 0) {
			return false;
		}
	}
	return true;
}

long long maxStepOfTwoRes(const std::vector<int>& A) {
	int minStep = A[0], max=A[0];
	for (int i = 1; i < A.size(); i++) {
		if (minStep > A[i]) {
			minStep = A[i];
		}
		if (max < A[i]) {
			max = A[i];
		}
		if (max < minStep * (i + 1)) {
			max = minStep * (i + 1);
		}
	}
	return max;
}

long long max_segment(std::vector<int> A) {
	//std::set<long long>values;
	int size = A.size();
	int min = 0, max = 0;
	if (checkIfAllAreEven(A)) {
		long long res = maxStepOfTwoRes(A);
		return res;
	}
	int currentgcd = 0;
	long long result = A.size();
	/*for (int i = 1; i <= A.size(); i++) {
		values.insert(i);
	}*/
	long long val = 0;
	bool shouldBreak = false;
	for (int i = 0; i < size; i++) {
		shouldBreak = false;
		for (int r = i; r < size; r++) {
			currentgcd = A[i];
			if (result < A[i]) {
				result = A[i];
			}
			for (int l = i + 1; l <= r; l++) {
				currentgcd = gcd(currentgcd, A[l]);
				if (currentgcd == 1) {
					shouldBreak = true;
					break;
				}
				/*values.insert(((l + 1) - (i + 1) + 1) * currentgcd);*/
				val = ((l + 1) - (i + 1) + 1) * currentgcd;
				if (result < val) {
					result = val;
				}
			}
			if (shouldBreak)
				break;
		}
	}
	//const auto it = values.rbegin();
	return result;
}