#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int INF = 1e8;
const int MAXN = 2e5 + 5;
const int MAXM = 3 * MAXN;
int n, m, k;

vector <pair<int,int>> G[MAXN];

int d[MAXN];
bool used[MAXN][10];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> k;

    for (int i = 1; i <= m; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;

        G[a].push_back({b, c});
        G[b].push_back({a, c});
    }

    for (int i = 2; i <= n; i++)
        d[i] = INF;

    priority_queue <pair<pair<int, int>, int>> pq;
    pq.push({{1, 0}, 0});

    while (!pq.empty())
    {
        pair <int, int> curr = pq.top().first;
        int cntPlanes = pq.top().second;
        pq.pop();

        int v = curr.first;
        int type = curr.second;

        if (used[v][cntPlanes]) continue;
        used[v][cntPlanes] = 1;

        for (int i = 0; i < G[v].size(); i++)
        {
            if (G[v][i].second == 2) cntPlanes++;

            if (cntPlanes > k) continue;

            if (d[v] + 1 < d[G[v][i].first])
            {
                d[G[v][i].first] = d[v] + 1;
            }
            pq.push({G[v][i], cntPlanes});
        }
    }

    cout << (d[n] == INF ? -1 : d[n]) << endl;


    return 0;
}
/**
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2

3
*/

