#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int INF = 1e8;
const int MAXN = 2e5 + 5;
const int MAXM = 3 * MAXN;
int n, m, k;

vector <pair<int,int>> G[MAXN];

int d[MAXN];
bool used[MAXN];

void dfs(int s, int cntPlanes = 0)
{
    if (used[s]) return;
    used[s] = 1;

    for (int i = 0; i < G[s].size(); i++)
    {
        int v = G[s][i].first;
        int t = G[s][i].second;
        if (t == 2) cntPlanes++;

        if (cntPlanes > k) return;

        d[v] = min(d[v], d[s] + 1);

        dfs(v, cntPlanes);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> k;

    for (int i = 1; i <= m; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;

        G[a].push_back({b, c});
        G[b].push_back({a, c});
    }

    for (int i = 2; i <= n; i++)
        d[i] = INF;

    dfs(1);

    cout << (d[n] == INF ? -1 : d[n]) << endl;

    return 0;
}
/**
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2

3
*/
