#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int INF = 1e8;
const int MAXN = 2e5 + 5;
const int MAXM = 3 * MAXN;
const int MAXK = 5;
int n, m, k;

vector <pair<int,int>> G[MAXN];

int d[MAXN][MAXK];
bool used[MAXN][MAXK];

int currentPlane = 0;

void dfs(int s, int cntPlanes = 0)
{
    if (used[s][0]) return;
    used[s][0] = 1;
    if (cntPlanes > k) return;

    for (int i = 0; i < G[s].size(); i++)
    {
        int v = G[s][i].first;
        int t = G[s][i].second;
        bool isPlane = (t == 2);

        if (isPlane && v != currentPlane) continue;

        d[v][0] = min(d[v][0], d[s][0] + 1);

        dfs(v, cntPlanes + isPlane);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> k;

    for (int i = 1; i <= m; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;

        G[a].push_back({b, c});
        G[b].push_back({a, c});
    }

    for (int i = 1; i <= n; i++)
    {
        sort(G[i].begin(), G[i].end());
    }




    int ans = INF;

    for (int i = 1; i <= n; i++)
    {
        for (int i = 1; i <= n; i++)
            for (int j = 0; j <= k + 1; j++)
                used[i][j] = 0;

        for (int i = 2; i <= n; i++)
            for (int j = 0; j <= k + 1; j++)
                d[i][j] = INF;


        currentPlane = i;
        dfs(1);
        int tmp = INF;

        for (int i = 0; i <= k; i++)
            tmp = min(tmp, d[n][i]);

        ans = min(ans, tmp);
    }

    cout << (ans == INF ? -1 : ans) << endl;

    return 0;
}
/**
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2

3
*/
