#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int INF = 1e8;
const int MAXN = 2e5 + 5;
const int MAXM = 3 * MAXN;
const int MAXK = 5;
int n, m, k;

vector <pair<int,int>> G[MAXN];

int d[MAXN][MAXK];
int used[MAXN][MAXK];

bool cmp(pair<int,int> a, pair<int,int> b)
{
    return a.second < b.second;
}

void dfs(int s, int cntPlanes)
{
    if (cntPlanes > k) return;

    for (int i = 0; i <= cntPlanes; i++)
        if (used[s][i]) return;

    used[s][cntPlanes] = 1;

    for (int i = 0; i < G[s].size(); i++)
    {
        int v = G[s][i].first;
        int t = G[s][i].second;
        bool isPlane = (t == 2);

        d[v][cntPlanes + isPlane] = min(d[v][cntPlanes + isPlane], d[s][cntPlanes] + 1);

        dfs(v, cntPlanes + isPlane);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> k;

    for (int i = 1; i <= m; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;

        G[a].push_back({b, c});
        G[b].push_back({a, c});
    }

    for (int i = 1; i <= n; i++)
    {
        sort(G[i].begin(), G[i].end(), cmp);
    }

    for (int i = 2; i <= n; i++)
        for (int j = 0; j <= k + 1; j++)
            d[i][j] = INF;

    dfs(1, 0);

    int ans = INF;
    for (int i = 0; i <= k; i++)
        ans = min(ans, d[n][i]);

    cout << (ans == INF ? -1 : ans) << endl;

    return 0;
}
/**
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2

3
*/
