#include <bits/stdc++.h>
#define MAXI 5000005
#include "segment.h"
using namespace std;
long long segm_tree[MAXI*4];
vector<long long> a;
void build(long long node, long long L, long long R)
{
    if(L == R)
    {
        segm_tree[node] = a[L-1];
        return;
    }

    long long mid = (L+R)/2;
    build(node*2, L, mid);
    build(node*2+1, mid+1, R);
    segm_tree[node] = __gcd(segm_tree[node*2], segm_tree[node*2+1]);
}

long long query(long long node, long long L, long long R, long long l, long long r)
{
    if(L > r || R < l) return -1;
    if(L >= l && R <= r) return segm_tree[node];
    long long mid = (L+R)/2;
    long long s1 = query(node*2, L, mid, l, r);
    long long s2 = query(node*2+1, mid+1, R, l, r);
    if(s1 == -1) return s2;
    if(s2 == -1) return s1;
    return __gcd(s1, s2);
}

long long max_segment(std::vector<int> A)
{
    long long n = A.size();

    long long maxi = -1, br = 0;
    for(long long i = 0; i < n; i ++)
    {
        long long tek = A[i];
        if(A[i] > maxi) maxi = A[i];
        a.push_back(A[i]);
    }
    if(n > maxi) maxi = n;
    int gcd = -1, tek;

    if(n < 70005)
    {
        for(long long i = 0; i < n; i ++)
        {
            tek = A[i];
            for(long long j = i+1; j < n; j ++)
            {
                tek = __gcd(A[j], tek);
                if(tek == 1) break;
                if(tek*(j-i+1) > maxi) maxi = tek*(j-i+1);
            }
        }
    }
    else
    {
        long long broikabeibe = 1;
        for(long long i = 1; i < n; i ++)
        {
            if(a[i] == a[i-1]) broikabeibe ++;
            else
            {
                if(broikabeibe*a[i-1] > maxi) maxi = broikabeibe*a[i-1];
                broikabeibe = 1;
            }
        }
        if(broikabeibe*a[n-1] > maxi) maxi = broikabeibe*a[n-1];
    }
    return maxi;
}
/*
7
6 5 10 15 2 4 8

9
3 3 3 5 7 5 5 7 3
*/
