#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=2e5+5;
const int INF=1e9+5;

int n,m,k;
vector<int> adj[MAXN];
vector<pair<int,int> > edge2;
bool used[MAXN];
int dist[2][MAXN];

void bfs(int v)
{
    int ind=0;
    if(v==n) ind=1;
    for(int i=1;i<=n;i++) dist[ind][i]=INF;
    dist[ind][v]=0;
    memset(used,0,sizeof(used));
    used[v]=1;
    queue<int> q;
    q.push(v);
    while(!q.empty())
    {
        v=q.front();
        q.pop();
        for(int i=0;i<adj[v].size();i++)
        {
            if(!used[adj[v][i]])
            {
                used[adj[v][i]]=1;
                dist[ind][adj[v][i]]=dist[ind][v]+1;
                q.push(adj[v][i]);
            }
        }
    }
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m>>k;
for(int i=0;i<m;i++)
{
    int u,v,t;
    cin>>u>>v>>t;
    if(t==1)
    {
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    else edge2.push_back({u,v});
}

bfs(1);
bfs(n);

int ans=dist[0][n];
for(int i=0;i<edge2.size();i++)
{
    int u=edge2[i].first;
    int v=edge2[i].second;
    int d1=dist[0][u]+dist[1][v]+1;
    int d2=dist[1][u]+dist[0][v]+1;
    ans=min(ans, min(d1, d2));
}

if(ans<INF) cout<<ans<<endl;
else cout<<-1<<endl;

return 0;
}
