#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;
const int MAXM=2e5+5;
const int MAXK=105;

int n,m,d,k;
pair<int,int> edge[MAXM];
vector<pair<int,int> > adj[MAXN];
int c[MAXN];
int cDeg[MAXN];
int s[MAXK];
int mxD;

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int t;
cin>>t;
while(t--)
{
    cin>>n>>m>>d>>k;
    mxD=d/k;
    for(int i=0;i<m;i++)
    {
        cin>>edge[i].fi>>edge[i].se;
    }

    sort(edge,edge+m);
    int cnt=1;
    for(int i=1;i<m;i++)
    {
        if(edge[i]==edge[i-1]) cnt++; ///
        else
        {
            adj[edge[i-1].fi].push_back({edge[i-1].se,cnt});
            adj[edge[i-1].se].push_back({edge[i-1].fi,cnt});
            cnt=1;
        }
    }
    adj[edge[m-1].fi].push_back({edge[m-1].se,cnt});
    adj[edge[m-1].se].push_back({edge[m-1].fi,cnt});

    /*for(int i=1;i<=n;i++)
    {
        cout<<i<<":"<<endl;
        for(int j=0;j<adj[i].size();j++) cout<<adj[i][j].fi<<" "<<adj[i][j].se<<endl;
    }*/

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=k;j++) s[j]=0;
        for(int j=0;j<adj[i].size();j++)
        {
            auto nxt=adj[i][j];
            if(c[nxt.fi]==0) continue;
            s[c[nxt.fi]]+=nxt.se;
            if(cDeg[nxt.fi]+nxt.se>mxD) s[c[nxt.fi]]+=mxD;
        }
        for(int j=1;j<=k;j++)
        {
            if(s[j]<=mxD)
            {
                c[i]=j;
                break;
            }
        }
        for(int j=0;j<adj[i].size();j++)
        {
            auto nxt=adj[i][j];
            if(c[nxt.fi]!=c[i]) continue;
            cDeg[i]+=nxt.se;
            cDeg[nxt.fi]+=nxt.se;
        }
    }
    for(int i=1;i<=n;i++) cout<<(c[i]==0 ? 1/0 : c[i])<<" ";
    cout<<endl;
}

return 0;
}
