#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=1e5+5;
const int MAXM=2e5+5;
const int MAXK=105;

mt19937 mt(6734);

int n,m,d,k;
pair<int,int> edge[MAXM];
vector<pair<int,int> > adj[MAXN];
int c[MAXN];
int cDeg[MAXN];
int s[MAXK];
int mxD;
int p[MAXK];
int pn[MAXN];

void init()
{
    //edge.clear();
    for(int i=1;i<=n;i++) c[i]=0;
    for(int i=1;i<=n;i++) cDeg[i]=0;
    for(int i=1;i<=n;i++) adj[i].clear();
    iota(p+1,p+k+1,1);
    iota(pn+1,pn+n+1,1);
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int t;
cin>>t;
while(t--)
{
    cin>>n>>m>>d>>k;
    init();
    mxD=d/k;
    for(int i=0;i<m;i++)
    {
        cin>>edge[i].fi>>edge[i].se;
    }

    sort(edge,edge+m);
    int cnt=1;
    for(int i=1;i<m;i++)
    {
        if(edge[i]==edge[i-1]) cnt++; ///
        else
        {
            adj[edge[i-1].fi].push_back({edge[i-1].se,cnt});
            adj[edge[i-1].se].push_back({edge[i-1].fi,cnt});
            cnt=1;
        }
    }
    adj[edge[m-1].fi].push_back({edge[m-1].se,cnt});
    adj[edge[m-1].se].push_back({edge[m-1].fi,cnt});

    /*for(int i=1;i<=n;i++)
    {
        cout<<i<<":"<<endl;
        for(int j=0;j<adj[i].size();j++) cout<<adj[i][j].fi<<" "<<adj[i][j].se<<endl;
    }*/

    for(;;)
    {
        bool fl=0;
        shuffle(pn+1,pn+n+1,mt);
        for(int i=1;i<=n;i++) c[i]=0;
        for(int i=1;i<=n;i++) cDeg[i]=0;

        for(int i=1;i<=n;i++)
        {
            int v=pn[i];
            for(int j=1;j<=k;j++) s[j]=0;
            for(int j=0;j<adj[v].size();j++)
            {
                auto nxt=adj[v][j];
                if(c[nxt.fi]==0) continue;
                s[c[nxt.fi]]+=nxt.se;
                if(cDeg[nxt.fi]+nxt.se>mxD) s[c[nxt.fi]]+=mxD;
            }
            //if(n>900 && i==n/2) shuffle(p+1,p+k+1,mt);
            for(int j=1;j<=k;j++)
            {
                if(s[p[j]]<=mxD)
                {
                    c[v]=p[j];
                    break;
                }
            }
            for(int j=0;j<adj[v].size();j++)
            {
                auto nxt=adj[v][j];
                if(c[nxt.fi]!=c[v]) continue;
                cDeg[v]+=nxt.se;
                cDeg[nxt.fi]+=nxt.se;
            }
        }
        for(int i=1;i<=n;i++) if(c[i]==0) {fl=1; break;}
        if(!fl) break;
    }
    for(int i=1;i<=n;i++) cout<<c[i]<<" ";
    cout<<endl;
}

return 0;
}
