#include<bits/stdc++.h>
using namespace std;
mt19937 mt(343);
const int MAXN=1e5+6;
vector<int>g[MAXN];
int pos[MAXN];
int invpos[MAXN];
int n,m,d,k;
int colors[MAXN];
int colors_real[MAXN];
bool c[MAXN];
int cnt_neigh[MAXN][2];
bool in_play[MAXN];
vector<int> divide(vector<int>vertices, int maxdeg1, int maxdeg2,int col)
{
    shuffle(vertices.begin(),vertices.end(),mt);
    vector<int> to_swap;
    int maxdeg[2]={maxdeg1, maxdeg2};
    for(int i=0;i<vertices.size();i++)
    {
        int u=vertices[i];
        cnt_neigh[u][0]=0;
        cnt_neigh[u][1]=0;
        c[u]=1;
        for(auto xd:g[vertices[i]])
        {
            if(in_play[xd])cnt_neigh[u][1]++;
        }
        if(cnt_neigh[u][c[u]]>maxdeg[c[u]])to_swap.push_back(u);
    }
    int op=0;
    while(!to_swap.size()==0)
    {
        int u=to_swap.back();to_swap.pop_back();
        if(cnt_neigh[u][c[u]]<=maxdeg[c[u]])continue;
        for(auto xd:g[u])
        {
            if(in_play[xd])
            {
                cnt_neigh[xd][c[u]]--;
                cnt_neigh[xd][1-c[u]]++;
                if(cnt_neigh[xd][1-c[u]]>maxdeg[1-c[u]])
                {
                    to_swap.push_back(xd);
                }
            }
        }
        c[u]=1-c[u];
        //for(int i=1;i<=n;i++)cout<<c[i]<<" ";
        //cout<<endl;
    }
    vector<int>vertices1;
    for(int i=0;i<vertices.size();i++)
    {
        int u=vertices[i];
        if(c[u]==0)
        {
            in_play[u]=0;
            colors[u]=col;
        }
        else
        {
            vertices1.push_back(u);
        }
    }
    return vertices1;
}
void solve()
{
    cin>>n>>m>>d>>k;
    for(int i=1;i<=n;i++)
    {
        colors[i]=0;
        pos[i]=i;
        g[i].clear();
    }
    shuffle(pos+1,pos+n+1,mt);
    for(int i=1;i<=n;i++)
    {
        invpos[pos[i]]=i;
    }
    for(int i=1;i<=m;i++)
    {
        int a,b;
        cin>>a>>b;
        a=pos[a];
        b=pos[b];
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<int>vertices;
    for(int i=1;i<=n;i++)vertices.push_back(i);
    for(int i=1;i<=n;i++)in_play[i]=1;
    for(int i=1;i<=n;i++)colors[i]=1;
    for(int j=k;j>=2;j--)
    {
        vertices=divide(vertices, d/k, d-(k-j+1)*((d+k-1)/k),j);
    }
    for(int i=1;i<=n;i++)
    {
        colors_real[invpos[i]]=colors[i];
    }
    for(int i=1;i<=n;i++)cout<<colors_real[i]<<" ";
    cout<<endl;
}
int main()
{
    int t;
    cin>>t;
    while(t--)solve();
return 0;
}
