#include <iostream>
#include <vector>

struct Trip
{
    int a;
    int b;
    int t;
};

std::vector<Trip> GetTripsFrom(int town, std::vector<Trip>& trips) {
    std::vector<Trip> subTrips;
    int iterations = trips.size();
    for (int i = 0; i < iterations; i++) {
        if (town == trips[i].a) subTrips.push_back(trips[i]);
    }
    return subTrips;
}

void SeeTrip(Trip trip, int len) {
    std::cout << " a: " << trip.a << " b: " << trip.b << " t: " << trip.t << " len: " << len << '\n';
}

void GetTrip(Trip& trip, std::vector<Trip>& trips, int lenght, int& N, std::vector<int>& lenghts, int& K, int planesCount) {
    //SeeTrip(trip, lenght);
    if (planesCount > K) return;
    if (trip.b == N) {
        lenghts.push_back(lenght);
        return;
    }

    std::vector<Trip> possibleTrips = GetTripsFrom(trip.b, trips);

    for (int i = 0; i < possibleTrips.size(); i++) {
        if (possibleTrips[i].t == 2) planesCount++;
        int newLen = lenght + 1;
        GetTrip(possibleTrips[i], trips, newLen, N, lenghts, K, planesCount);
    }
}

int main()
{
    int N, M, K;
    std::cin >> N >> M >> K;

    std::vector<Trip> trips;

    for (int i = 0; i < M; i++) {
        Trip trip;
        std::cin >> trip.a >> trip.b >> trip.t;
        trips.push_back(trip);
    }

    std::vector<int> lenghts;
    std::vector<Trip> start = GetTripsFrom(1, trips);

    for (int i = 0; i < start.size(); i++) {
        int planeCount = 0;
        if (start[i].t == 2) planeCount++;
        GetTrip(start[i], trips, 1, N, lenghts, K, planeCount);
    }

    if (lenghts.size() == 0) {
        std::cout << -1;
        return 0;
    }

    int minLeinght = lenghts[0];
    for (int i = 1; i < lenghts.size(); i++) {
        if (lenghts[i] < minLeinght) minLeinght = lenghts[i];
    }

    std::cout << minLeinght;

    return 0;
}
