#include<iostream>
#include<vector>
using namespace std;

int n, m, k;
bool used[100002];
vector<pair<int, int>> graph[100002];

void Read() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int u, v, t;
    cin >> n >> m >> k;
    for (int i=0; i<m; i++) {
        cin >> u >> v >> t;
        graph[u].push_back({v, t});
        graph[v].push_back({u, t});
    }

    return ;
}

int DFS(int u, int brs) {
    used[u] = true;
    if (u == n) return 1;
    int br = 1000000;

    for (int i=0; i<graph[u].size(); i++) {
        pair<int, int> v = graph[u][i];
        if (!used[v.first]) {
            if (v.second == 2 && brs + 1 <= k) {
                br = min(br, DFS(v.first, brs + 1));
            } else if (v.second == 1) {
                br = min(br, DFS(v.first, brs));
            }
        }
    }

    used[u] = false;
    return br + 1;
}


int main() {
    Read();
    int otg = DFS(1, 0) - 1;
    if (otg == 1000000) cout << "-1" << endl;
    else cout << otg << endl;
    return 0;
}
