#include "segment.h"
///#include "Lgrader.cpp"
#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 3000000;
const int LOG = 22;

int n;
int a[MAXN + 5];
int st[MAXN + 5][LOG + 5];

int query(int l, int r)
{
    int ret = 0;
    for (int j = LOG; j >= 0; -- j)
    {
        if (l + (1ll << j) - 1 <= r)
        {
            ret = __gcd(ret, st[l][j]);
            l += (1ll << j);
        }
    }
    return ret;
}

long long max_segment(vector<int> A)
{
    n = A.size();
    for (int i = 0; i < n; ++ i)
    {
        a[i + 1] = A[i];
        st[i + 1][0] = a[i + 1];
    }

    for (int j = 1; j <= LOG; ++ j)
    {
        for (int i = 1; i <= n; ++ i)
        {
            if (i + (1ll << j) - 1 <= n) st[i][j] = __gcd(st[i][j - 1], st[i + (1ll << (j - 1))][j - 1]);
        }
    }

    long long ans = 1ll * n * query(1, n);
    for (int i = 1; i <= n; ++ i)
    {
        long long g = a[i], j = i;
        while (true)
        {
            while (j < n and 1ll * (j - i + 1) * g < ans)
            {
                j = i + (ans - 1) / g;
                if (j > n) break;
                g = query(i, j);
            }
            if (j > n) break;
            int l = j, r = n + 1, mid;
            while (r - l > 1)
            {
                mid = (l + r) / 2;
                if (query(i, mid) == g) l = mid;
                else r = mid;
            }
            j = l;
            ans = max(ans, 1ll * (j - i + 1) * g);
            j++;
            if (j > n) break;
            g = __gcd(g, 1ll * a[j]);
        }
    }
    return ans;
}
