#include<bits/stdc++.h>
#include "segment.h"

#define MAXN 3000003

using namespace std;

int n;
pair<int, int> st[MAXN][22];
long long ans;

void build(vector<int> &arr)
{
    for(int i = 0; i < n; i ++) st[i][0] = {arr[i], i};
    for(int i = 1; (1 << i) <= n; i ++)
    {
        for(int j = 0; j + (1 << i) <= n; j ++)
        {
            st[j][i] = min(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        }
    }
}
int pw(int p)
{
    int br = 0;
    while(p)
    {
        p /= 2;
        br ++;
    }
    return br - 1;
}
pair<int, int> queryMIN(int a, int b)
{
    if(b < a) swap(a, b);
    int sz = (b - a + 1);
    int p = pw(sz);
    return min(st[a][p], st[b - (1 << p) + 1][p]);
}
long long solve(int l, int r, vector<int> &arr)
{
    if(r < l) return -1;
    if(l == r) return arr[l];
    auto p = queryMIN(l, r);
    //cout<<l<<" "<<r<<" "<<cur<<endl;
    return ans = max(ans, max((long long)(r - l + 1) * p.first, max(solve(l, p.second - 1, arr), solve(p.second + 1, r, arr))));
}
long long max_segment(vector<int> arr)
{
    /*cout<<pw(2)<<endl;
    cout<<pw(3)<<endl;
    cout<<pw(4)<<endl;
    cout<<pw(1)<<endl;
    cout<<pw(7)<<endl;*/
    /*t.init();
    t.build(0, 0, n - 1);*/
    n = arr.size();
    build(arr);
    return solve(0, n - 1, arr);
}
