#include<bits/stdc++.h>
#include "segment.h"

#define MAXN 3000003

using namespace std;

vector<int> arr;
int n;
pair<long long, pair<long long, long long> > st[MAXN][23];
long long ans;
long long gcd(long long a, long long b)
{
    if(a == -1) return b;
    if(b == -1) return a;
    while(b)
    {
        long long r = b;
        b = a % b;
        a = r;
    }
    return a;
}

void build()
{
    for(int i = 0; i < n; i ++) st[i][0] = {arr[i], {arr[i], i}};
    for(int i = 1; (1 << i) <= n; i ++)
    {
        for(int j = 0; j + (1 << i) <= n; j ++)
        {
            st[j][i] = {gcd(st[j][i - 1].first, st[j + (1 << (i - 1))][i - 1].first), min(st[j][i - 1].second, st[j + (1 << (i - 1))][i - 1].second)};
        }
    }
}
long long pw(long long p)
{
    long long br = 0;
    while(p)
    {
        p /= 2;
        br ++;
    }
    return br - 1;
}
long long queryGCD(long long a, long long b)
{
    if(b < a) swap(a, b);
    long long sz = (b - a + 1);
    long long p = pw(sz);
    return gcd(st[a][p].first, st[b - (1 << p) + 1][p].first);
}
pair<long long, long long> queryMIN(long long a, long long b)
{
    if(b < a) swap(a, b);
    long long sz = (b - a + 1);
    long long p = pw(sz);
    return min(st[a][p].second, st[b - (1 << p) + 1][p].second);
}
long long all(long long l, long long r, long long ind)
{
    long long cur = 0;
    for(long long i = l; i <= ind; i ++)
    {
        for(long long j = max(ind, i); j <= r; j ++)
        {
            cur = max(cur, (j - i + 1) * queryGCD(i, j));
        }
    }
    return cur;
}
long long solve(long long l, long long r)
{
    if(r < l) return -1;
    if(l == r) return arr[l];
    auto p = queryMIN(l, r);
    long long cur = 0;
    if((r - l + 1) * p.first > ans) cur = all(l, r, p.second);
    //cout<<l<<" "<<r<<" "<<cur<<endl;
    return ans = max(ans, max(cur, max(solve(l, p.second - 1), solve(p.second + 1, r))));
}
long long max_segment(vector<int> A)
{
    n = A.size();
    long long ans = n;
    for(long long i = 0; i < n; i ++)
    {
        arr.push_back(A[i]);
    }
    build();
    /*if(n <= 500)
    {

    return solve(0, n - 1);
    }*/
    /*else
    {*/
    if(n <= 70000)
    {
        for(int i = 0; i < n; i ++)
        {
            for(int j = i; j < n; j ++)
            {
                long long g = queryGCD(i, j);
                //cout<<(long long)(j - i + 1) * g<<endl;
                ans = max(ans, (long long)(j - i + 1) * g);
                if(g == 1 || (g * (long long)(n - i) < ans)) break;
            }
        }
    }
    else
    {
        for(int i = 0; i < n; i ++)
        {
            long long l = i, r = n - 1;
            long long cur = arr[i];
            int g = 0;
            while(l + 1 < r)
            {
                int mid = (l + r) / 2;
                g = queryGCD(i, mid);
                if(g * (mid - i + 1) < cur) r = mid;
                else
                {
                    l = mid;
                    cur = g * (mid - i + 1);
                }
            }
            //cout<<i<<" "<<l<<endl;
            for(int j = r; j < n; j ++)
            {
                long long g = queryGCD(i, j);
                //cout<<(long long)(j - i + 1) * g<<endl;
                ans = max(ans, (long long)(j - i + 1) * g);
                if(g == 1 || (g * (long long)(n - i) < ans)) break;
            }
            ans = max(ans, cur);
        }
    }

        return ans;
    //}
}
