#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
long long const MAXN = 2 * 1e5 + 2;
long long n, m, k,a,b,t,cur;
vector<long long > buses[MAXN];
long long erasing[MAXN];
vector<pair<long long,long long>> planes;
pair<long long, long long> ans[MAXN];

void input()
{
    cin >> n >> m >> k;
    for(long long i = 0; i < m; i++)
    {
        cin >> a >> b >> t;
        if(t == 1){
            buses[a].push_back(b);
            buses[b].push_back(a);
        }
        else{
           planes.push_back(make_pair(a,b));
        }
    }
    //cout << "Finished Input!" << endl;
}
long long calc()
{
    bool visited[MAXN];
    for(int i = 1; i <= n; i++)visited[i]=false;
    long long ans[MAXN];
     for(int i = 1; i <= n; i++)ans[i]=0;
    queue<long long> q;
    q.push(1);
    while(q.empty()==false && ans[n] == 0){
        long long cur = q.front(),next;
        q.pop();
        visited[cur] = true;
        for(long long i = 0; i < buses[cur].size() - erasing[cur];i++){
            next = buses[cur][i];
            if(visited[next])continue;
            if(ans[next] == 0 || ans[next] > ans[cur] + 1)ans[next] = ans[cur] + 1;
            q.push(next);
        }
    }
    /*
    cout << "///////////" << endl;
    cout << "Printing Buses" << endl;
    for(long long i = 1; i <= n; i++){
            cout << i << " ";
        for(long long j = 0; j < buses[i].size() - erasing[cur]; j++){
            cout << buses[i][j] << " ";
        }
    cout << endl;
    }
    cout << endl;
    cout << "Printing results!" << endl;
    for(long long i = 1; i <= n; i++){
        cout << i <<" "<< ans[i] << endl;
    }
    cout << endl;
    */
    if(ans[n]==0)return -1;
    else return ans[n];

}
// K = 1
long long bfs()
{
   long long mini = LONG_MAX,x,y;
   //K = 0
   long long val = calc();
   if(val != -1)mini = min(mini,val);
   //cout << "K0" << val << endl;
   //cout << "Planes SIZE" << planes.size() << endl;
   long long Psize = planes.size();
   //K = 1
   for(long long j = 0; j < Psize; j++){
        x = planes[j].first;
        y = planes[j].second;
        buses[x].push_back(y);
        buses[y].push_back(x);
        val = calc();
        //cout << "K1" << val << endl;
        if(val != -1)mini = min(mini,val);
        //buses[x].erase(buses[y].end()-1,buses[y].end());
        //buses[y].erase(buses[x].end()-1,buses[x].end());
        erasing[x]++;
        erasing[y]++;
        //cout << mini << endl;
   }
   if(mini == LONG_MAX)return -1;
   else return mini;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    //cout << "testing" << endl;
    long long FinalAns = bfs();
    cout << FinalAns<< endl;
    return 0;
}
