#include<bits/stdc++.h>
#include "segment.h"
#define MAXN 70006
using namespace std;
typedef long long ll;
ll ch[MAXN];
ll SpT[MAXN][18];
ll n;
ll gcd(ll a, ll b){
    if(a<b){
        swap(a,b);
    }
    if(a==b){
        return a;
    }else if(a==0||b==0){
        return 0;
    }
    while(b!=0){
        ll q=b;
        b=a%b;
        a=q;
    }
    return a;
}
void build(){
    for(int i=0;i<n;i++){
        SpT[i][0]=ch[i];
    }
    for(int k=1;k<18;k++){
        for(int i=0;i<n;i++){
            if(i+(1<<(k-1))<n){
                SpT[i][k]=gcd(SpT[i][k-1],SpT[i+(1<<(k-1))][k-1]);
            }else{
                SpT[i][k]=1;
            }
        }
    }
}
ll logar(ll a){
    ll br=0;
    if(a==0||a==1){
        return 0;
    }
    ll x=1;
    while(x<a){
        br++;
        x*=2;
    }
    return br;
}
ll get_gcd(ll l, ll r){
    if(l>r){
        return 1;
    }else if(l==r){
        return ch[l-1];
    }else{
        l--;r--;
        ll k=logar(r-l+1);
        return gcd(SpT[l][k-1],SpT[r-(1<<(k-1))+1][k-1]);
    }
}
long long max_segment(std::vector<int> A){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    n=(int)A.size();
    for(int i=0;i<n;i++){
        ch[i]=A[i];
    }
    build();
    ll res=0;
    for(int i=1;i<=n;i++){
        for(int j=i;j<=n;j++){
            res=max(res,(j-i+1)*get_gcd(i,j));
        }
    }
    return res;
}