#include<iostream>
#include<vector>
#include<math.h>
#include "segment.h"
#define MAXN 3000006
using namespace std;
typedef long long ll;
int ch[MAXN];
int SpT[MAXN][18];
int n;
int gcd(int a, int b){
   if(a==0){
        return 0;
    }
    while(b!=0){
        ll q=b;
        b=a%b;
        a=q;
    }
    return a;
}
void build(){
    for(int i=0;i<n;i++){
        SpT[i][0]=ch[i];
    }
    for(int k=1;k<18;k++){
        for(int i=0;i<n;i++){
            if(i+(1<<(k-1))<n){
                SpT[i][k]=gcd(SpT[i][k-1],SpT[i+(1<<(k-1))][k-1]);
            }else{
                SpT[i][k]=1;
            }
        }
    }
}
int logar(ll a){
    ll br=0;
    if(a==0||a==1){
        return 0;
    }
    ll x=1;
    while(x<a){
        br++;
        x*=2;
    }
    return br;
}
ll get_gcd(int l, int r){
    if(l==r){
        return ch[l-1];
    }else{
        l--;r--;
        ll k=logar(r-l+1);
        return gcd(SpT[l][k-1],SpT[r-(1<<(k-1))+1][k-1]);
    }
}
bool dali=true;
int stepen[MAXN];
bool prime=true;
long long max_segment(std::vector<int> A){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    n=(int)A.size();
    for(int i=0;i<n;i++){
        ch[i]=A[i];
        if(dali){
            int k=logar(ch[i]);
            if(ch[i]!=(1<<k)){
                dali=false;
            }else{
                stepen[i]=k;
            }
        }
    }
    ll res=n;
    if(dali){
           for(int k=1;k<=30;k++){
                int curr=0;
                for(int i=0;i<n;i++){
                    if(stepen[i]>=k){
                        curr++;
                    }else{
                        res=max(res,(ll)curr*(1<<k));
                        curr=0;
                    }
                }
                 res=max(res,(ll)curr*(1<<k));
           }
    }else{
        build();
        for(int i=0;i<n;i++){
            if(SpT[i][1]>1){
                prime=false;
            }
        }
        if(prime){
            int curr=1,prev=ch[0];
            for(int i=1;i<n;i++){
                if(ch[i]==prev){
                    curr++;
                }else{
                    res=max(res,(ll)curr*prev);
                    curr=1;
                }
            }
            res=max(res,(ll)curr*prev);
        }else{
            for(int i=1;i<=n;i++){
                for(int j=i;j<=n;j++){
                    res=max(res,(j-i+1)*get_gcd(i,j));
                }
            }
        }
    }
    return res;
}

