#include<iostream>
#include "segment.h"
#include <bits/stdc++.h>

using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; };
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; };

#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "   "

typedef long long ll;

const int MAX_N = 1e6 + 42;
const ll MAX_VAL = 2e9 + 42;
//const ll MAX_VAL = 100;
const int mod = 1e9 + 7;

bool prime[MAX_N];
std::vector< int > primes;
void eratosten( ){
    for( int i=2 ; i < sqrt( MAX_VAL ) ; i ++ ){
        if( prime[i] ) continue;
        primes.push_back( i );
        for( int j = i + i ; j < sqrt( MAX_VAL ) ; j ++ ) prime[j] = true;
    }
}
ll pw[MAX_N];
long long max_segment(std::vector<int> a){

    ll n = (ll)a.size();
    ll nas = n;

    eratosten();

    int last = 0;
    chkmax( nas, a[0] );
    for( int i=1 ; i < n ; i++ ){
        if( a[i] != a[i-1] ){
            //cerr << out( i ) << out( last ) << out( a[i-1] ) << out( (ll)(i - last ) * a[i-1] ) << endl;
            chkmax( nas, (ll)(i - last ) * a[i-1] );
            last = i;
        }
    }
    cerr << out( n ) << " - " << out( last ) << endl;
    chkmax( nas, (ll)( n - last ) * a[n-1] );

    for( auto currP : primes ){

        ll currPw = 1;
        int currSt = 0;
        while( true ){
            if( currPw > MAX_VAL ) break;
            pw[currSt] = currPw;
            currSt ++;
            currPw *= currP;
        }
        cerr << out( currP ) << endl;
        std::vector< ll > b( n );

        for( int i = 0 ; i < n ; i++ ){
            int st = 0;
            chkmax( nas, a[i] );
            while( a[i] % currP == 0 ){
                st ++;
                a[i] /= currP;
            }
            b[i] = st;
        }

        std::stack< std::pair< ll, ll > > S;
        std::vector< ll > c( n );
        for( int i=0 ; i < n ; i ++ ){
            while( !S.empty() and S.top().first > b[i] ){
                c[S.top().second] = i;
                S.pop();
            }
            S.push({ b[i], i });
        }

        while( !S.empty() ){
            c[S.top().second] = n-1;
            S.pop();
        }

        std::vector< ll > d( n );
        for( int i=n-1 ; i >= 0 ; i -- ){
            while( !S.empty() and S.top().first > b[i] ){
                d[S.top().second] = i;
                S.pop();
            }
            S.push({ b[i], i });
        }


        while( !S.empty() ){
            d[S.top().second] = 0;
            S.pop();
        }

        cerr << " ananasko " << endl;

    /*
        for( int i=0 ; i < n ; i++ ){
            cerr << out( i ) << out( b[i] ) << out( c[i] ) << out( d[i] ) << endl;
        }
    */

        chkmax( nas, a[n-1] );
        cerr << out( a[n-1] ) << endl;
        for( int i=0 ; i < n ; i++ ){
            cerr << out( c[i] - i ) << out( a[i] ) << endl;
            chkmax( nas, (ll)( c[i] - i ) * pw[b[i]]);
            chkmax( nas, (ll)( i - d[i] ) * pw[b[i]] );
        }
    }

    last = 0;
    chkmax( nas, a[0] );
    for( int i=1 ; i < n ; i++ ){
        if( a[i] != a[i-1] ){
            //cerr << out( i ) << out( last ) << out( a[i-1] ) << out( (ll)(i - last ) * a[i-1] ) << endl;
            chkmax( nas, (ll)(i - last ) * a[i-1] );
            last = i;
        }
    }
    cerr << out( n ) << " - " << out( last ) << endl;
    chkmax( nas, (ll)( n - last ) * a[n-1] );

    return nas;
}
