#include <bits/stdc++.h>
using namespace std;
int n, m, k;
const int MAX_N = 200000;
const int inf = 10000000;
vector< pair <int, int> > graph[MAX_N];

bool visited[MAX_N];
int usedAirplanes;
int currLength;
int bestPath = inf;
int shortestFrom[MAX_N];
int shortestFromUsingAirplane[MAX_N];

void dfs(int currV, bool byAirplane)
{
    visited[currV] = true;
    if(currV == n - 1)
    {
        if(usedAirplanes <= k)
        {
            bestPath = min(bestPath, currLength);
        }
        shortestFrom[currV] = 0;
        shortestFromUsingAirplane[currV] = inf;
    }
    else
    {
        for(int i = 0; i < graph[currV].size(); i++)
        {
            if(!visited[graph[currV][i].first])
            {
                if(graph[currV][i].second == 1)
                {
                    if(shortestFrom[graph[currV][i].first] == inf + 1)
                    {
                        currLength++;
                        dfs(graph[currV][i].first, false);
                    }

                }
                else
                {
                    if(usedAirplanes + 1 <= k)
                    {
                        if(shortestFrom[graph[currV][i].first] == inf + 1)
                        {
                            currLength++;
                            usedAirplanes++;
                            dfs(graph[currV][i].first, true);
                        }
                    }
                }
            }
        }
    }
    if(byAirplane)
    {
        usedAirplanes--;
    }
    if(currV != n - 1)
    {
        for(int i = 0; i < graph[currV].size(); i++)
        {
            if(!visited[graph[currV][i].first])
            {
                if(graph[currV][i].second == 1)
                {
                    shortestFrom[currV] = shortestFrom[graph[currV][i].first] + 1;
                }
                else
                {
                    shortestFrom[currV] = inf;
                }
                if(usedAirplanes == 0)
                {
                    if(graph[currV][i].second == 2)
                    {
                        shortestFromUsingAirplane[currV] = shortestFrom[graph[currV][i].first] + 1;
                    }
                    else
                    {
                        shortestFromUsingAirplane[currV] = shortestFromUsingAirplane[graph[currV][i].first] + 1;
                    }
                    //shortestFromUsingAirplane[currV] = shortestFromUsingAirplane[graph[currV][i].first] + 1;
                }
                else
                {
                    shortestFromUsingAirplane[currV] = inf;
                }
            }
        }
    }
    visited[currV] = false;
    currLength--;


}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> k;
    for(int i = 0; i < m; i++)
    {
        int a, b, t;
        cin >> a >> b >> t;
        a--;
        b--;
        pair<int, int> p;
        p.first = b;
        p.second = t;
        graph[a].push_back(p);

        p.first = a;
        p.second = t;
        graph[b].push_back(p);

    }

    for(int i = 0; i < n; i++)
    {
        shortestFrom[i] = inf + 1;
        shortestFromUsingAirplane[i] = inf + 1;
    }

    dfs(0, false);

    if(shortestFrom[0] >= inf && shortestFromUsingAirplane[0] >= inf)
    {
        cout << -1;
    }
    else
    {
        cout << min(shortestFrom[0], shortestFromUsingAirplane[0]);
    }
    /*if(bestPath == inf)
    {
        cout << -1;
    }
    else
    {
        cout << bestPath;
    }*/
    return 0;
}
