#include <iostream>
#include <vector>
#include <queue>
#include <cstring>
using namespace std;
const int MAXN=2e5+10;
const int MAXM=6e6+10;
struct Edge {
    int a, b, type;
};
Edge ed[MAXM];
vector <pair <int,int> > v[MAXN];
queue <pair <int,int> > q;
int dist[MAXN][3];
int n, m, k;
void bfs(int start) {
    q.push({start,0});
    dist[start][0]=0;
    int cur;
    while (!q.empty()) {
        auto x=q.front();
        q.pop();
        cur=dist[x.first][x.second];
        //cout << x.first << ' ' << x.second << ' ' << cur << endl;
        for (auto i:v[x.first]) {
            if (i.second==2 && x.second==2) continue;
            if (dist[i.first][x.second+i.second-1]==-1) {
                dist[i.first][x.second+i.second-1]=cur+1;
                q.push({i.first,x.second+i.second-1});
            }
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k;
    for (int i=0;i<m;i++) {
        cin >> ed[i].a >> ed[i].b >> ed[i].type;
        v[ed[i].a].push_back({ed[i].b,ed[i].type});
        v[ed[i].b].push_back({ed[i].a,ed[i].type});
    }
    memset(dist,-1,sizeof(dist));
    bfs(1);
    int ans=3*n;
    if (dist[n][k]!=-1) ans=min(ans,dist[n][k]);
    if (dist[n][k-1]!=-1) ans=min(ans,dist[n][k-1]);
    if (k==2 && dist[n][k-2]!=-1) ans=min(ans,dist[n][k-2]);
    if (ans==3*n) cout << -1 << endl;
    else cout << ans << endl;
    return 0;
}
/*
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2
*/
