#include "segment.h"
#include <iostream>
#include <vector>
#include <cmath>
#include <stack>
#include <algorithm>
using namespace std;
const int MAXN=3e6+10;
const int LOG=22;
stack <int> pesho;
int sp[LOG][MAXN], x[MAXN], ri[MAXN];
int stepen[MAXN];
long long cur;
int n;
int interval(int l, int r) {
    int st=stepen[r-l+1];
    return __gcd(sp[st][l],sp[st][r-(1<<st)+1]);
}
int find_next(int beg, int i) {
    int l, r, mid;
    l=i+1; r=n-1;
    while (l<=r) {
        mid=(l+r)/2;
        if (interval(beg,mid)==cur) l=mid+1;
        else r=mid-1;
    }
    return l-1;
}
long long max_segment(vector <int> a) {
    n=a.size();
    bool fl=true;
    for (int i=0;i<n;i++) {
        if (fl) {
            long long st=0;
            while ((1ll<<st)<(long long)a[i]) st++;
            if ((1ll<<st)!=(long long)a[i]) fl=false;
            x[i]=st;
        }
        sp[i][0]=a[i];
    }
    if (fl) {
        for (int i=n-1;i>=0;i--) {
            while (!pesho.empty() && x[pesho.top()]>=x[i]) pesho.pop();
            if (pesho.empty()) ri[i]=n;
            else ri[i]=pesho.top();
            pesho.push(i);
        }
        long long ans=0, cur, len;
        for (int i=0;i<n;i++) {
            int j=i;
            cur=a[i];
            while (j<n) {
                len=ri[j]-i;
                ans=max(ans,len*cur);
                j=ri[j];
                if (j==n) break;
                cur=a[j];
            }
        }
        return ans;
    }
    for (int i=1;(1<<i)<=n;i++) {
        for (int j=0;j+(1<<i)<=n;j++) {
            sp[i][j]=__gcd(sp[i-1][j],sp[i-1][j+(1<<(i-1))]);
        }
    }
    int br=1;
    for (int i=1;i<=n;i++) {
        if ((1<<(br+1))<i) br++;
        stepen[i]=br;
    }
    long long ans=0, len;
    int gr;
    for (int i=0;i<n;i++) {
        cur=a[i];
        gr=find_next(i,i);
        while (gr<n) {
            len=gr-i+1;
            ans=max(ans,cur*len);
            if (gr==n-1) break;
            gr++;
            cur=interval(i,gr);
            gr=find_next(i,gr);
        }
    }
    return ans;
}
/*
int main () {
    cout << max_segment({2,2,1,4,4,8,2}) << endl;
    return 0;
}*/
