#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>

#include "segment.h"

using namespace std;

const int MAXN = 3e6 + 3;
const int MAX_LOG = 22;

int rmq_gcd[MAXN][MAX_LOG];

void calc_rmq(vector<int> &nums) {
    int n = (int) nums.size();

    for (int i = 0; i < n; ++i) {
        rmq_gcd[i][0] = nums[i];
    }

    for (int interval = 1; interval < MAX_LOG; ++interval) {
        for (int i = 0; i + (1 << interval) - 1 < n; ++i) {
            int j = i + (1 << (interval - 1));

            rmq_gcd[i][interval] = __gcd(rmq_gcd[i][interval - 1], rmq_gcd[j][interval - 1]);
        }
    }
}

long long max_segment(vector<int> nums) {
    return 1;
}

