#include <iostream>
#include "segment.h"
#define MAX_N 3000006
using namespace std;

long long table[20][MAX_N];
long long tpow[20];

void fill_tpow()
{
    tpow[0]=1;
    for(int i=1; i<20; i++)
    {
        tpow[i]=tpow[i-1]*2;
    }
}


long long max_segment(std::vector<int> A)
{
    fill_tpow();
    int j=0;

    long long ans=0;

    while(tpow[j]<=A[0])
    {
        table[j][0]=tpow[j];
        j++;
    }

    for(int i=1; i<A.size(); i++)
    {
        j=0;
        //cout << A[i] << " ";
        while(j<20 && tpow[j]<=A[i])
        {
            //cout << tpow[j] << " ";
            table[j][i]=table[j][i-1]+tpow[j];
            //cout << table[j][i] << " ";
            if(table[j][i]>ans)
            {
                ans=table[j][i];
            }
            j++;
        }
        //cout << endl;

    }
    return ans;
}
