// set path=%path%;C:\Program Files\CodeBlocks\MinGW\bin
#include <bits/stdc++.h>

#define NAYG_V 200005

int64_t v;
int64_t r;
int64_t s;

struct Rebro {
	int64_t kwm;
	int64_t sled;
	int64_t vid;
};

std::vector<Rebro> rebra;
int64_t pwrvi_rebra[NAYG_V];

bool poseteno[NAYG_V * 3];

qislo_ot_vrwh_i_samoleti(int64_t vrwh, int64_t samoleti) {
	return samoleti * v + vrwh;
}

void dobavi_rebro(int64_t ot, int64_t kwm, int64_t vid) {
	rebra.push_back(Rebro{.kwm = kwm, .sled = pwrvi_rebra[ot], .vid = vid});
	pwrvi_rebra[ot] = rebra.size() - 1;
}

int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	
	std::cin >> v >> r >> s;
	
	for (int64_t i = 0; i < v; i += 1) {
		pwrvi_rebra[i] = -1;
	}
	
	for (int64_t i = 0; i < r; i += 1) {
		int64_t a;
		int64_t b;
		int64_t vid;
		std::cin >> a >> b >> vid;
		dobavi_rebro(a - 1, b - 1, vid - 1);
		dobavi_rebro(b - 1, a - 1, vid - 1);
	}
	
	struct Xt {
		int64_t v;
		int64_t s;
		int64_t r;
	};
	
	std::queue<Xt> xt;
	xt.push({.v = 0, .s = s, .r = 0});
	
	while (!xt.empty()) {
		Xt seg = xt.front();
		xt.pop();
		{
			int64_t qislo = qislo_ot_vrwh_i_samoleti(seg.v, seg.s);
			if (poseteno[qislo]) continue;
			poseteno[qislo] = true;
		}
		
		if (seg.v == v - 1) {
			std::cout << seg.r;
			return 0;
		}
		
		for (int64_t i = pwrvi_rebra[seg.v]; i != -1; i = rebra[i].sled) {
			Xt nov = {.v = rebra[i].kwm, .s = seg.s - rebra[i].vid, .r = seg.r + 1};
			if (nov.s < 0) continue;
			if (poseteno[qislo_ot_vrwh_i_samoleti(nov.v, nov.s)]) continue;
			xt.push(nov);
		}
	}
	
	std::cout << -1;
	return 0;
}