// set path=%path%;C:\Program Files\CodeBlocks\MinGW\bin
#include <bits/stdc++.h>

#include "segment.h"

int64_t nod(int64_t a, int64_t b) {
	if (b == 0) return a;
	return nod(b, a % b);
}

long long max_segment_n2(std::vector<int> a) {
	int64_t n = a.size();
	int64_t otg = 0;
	for (int64_t l = 0; l < n; l += 1) {
		int64_t seg_nod = a[l];
		for (int64_t d = l; d < n; d += 1) {
			seg_nod = nod(seg_nod, a[d]);
			otg = std::max(otg, seg_nod * (d - l + 1));
		}
	}
	return otg;
}

long long max_segment_prosti(std::vector<int> a) {
	int64_t n = a.size();
	int64_t otg = n;

	int64_t dwljina = 1;
	
	for (int64_t i = 1; i < n; i += 1) {
		if (a[i] == a[i-1]) {
			dwljina += 1;
		} else {
			otg = std::max(otg, dwljina * a[i-1]);
			dwljina = 1;
		}
	}
	otg = std::max(otg, dwljina * a[n-1]);
	return otg;
}

long long max_segment_2x(std::vector<int> a) {
	int64_t n = a.size();

	int64_t dwljina[31] = {};
	
	int64_t otg = 0;
	
	for (int64_t i = 0; i < n; i += 1) {
		for (int64_t y = 0; y < 31; y += 1) {
			if ((1 << y) <= a[i]) dwljina[y] += 1;
			else                  dwljina[y]  = 0;
			
			otg = std::max(otg, (1 << y) * dwljina[y]);
		}
	}
	
	return otg;
}

#define NAYG_N 500005

std::bitset<NAYG_N> sa_slojni;
std::vector<int64_t> prosti;

int64_t dwljina[NAYG_N];
int64_t sled[NAYG_N];

long long max_segment_obxto(std::vector<int> a) {
	int64_t otg = a.size();
	
	sa_slojni[0] = true;
	sa_slojni[1] = true;
	
	for (int64_t i = 0; i < (int64_t)sa_slojni.size(); i += 1) {
		if (sa_slojni[i]) continue;
		prosti.push_back(i);
		for (int64_t y = i + i; y < (int64_t)sa_slojni.size(); y += i) {
			sa_slojni[y] = true;
		}
	}
	
	for (int64_t i = 0; i < (int64_t)a.size(); i += 1) {
		std::vector<int64_t> prosti_deliteli;
		std::vector<int64_t> prosti_pokazateli;
		std::vector<int64_t> prosti_stepeni;
		
		{
			int64_t prost_indeks = 0;
			int64_t w = a[i];
			while (w > 1) {
				if (w % prosti[prost_indeks] == 0) {
					prosti_deliteli.push_back(prosti[prost_indeks]);
					prosti_pokazateli.push_back(0);
					prosti_stepeni.push_back(1);
					while (w % prosti[prost_indeks] == 0) {
						w /= prosti[prost_indeks];
						prosti_pokazateli[prosti_pokazateli.size() - 1] += 1;
						prosti_stepeni   [prosti_stepeni   .size() - 1] *= w;
					}
				}
				prost_indeks += 1;
			}			
		}
		
		if (prosti_deliteli.size() == 0) continue;
		
		std::vector<int64_t> seg_pokazateli(prosti_pokazateli.size());
		int64_t nod = 1;
		
		while (true) {
			int64_t y;
			for (y = 0; y < (int64_t)seg_pokazateli.size(); y += 1) {
				if (seg_pokazateli[y] == prosti_pokazateli[y]) {
					seg_pokazateli[y] = 0;
					nod /= prosti_stepeni[y];
				} else {
					seg_pokazateli[y] += 1;
					nod *= prosti_deliteli[y];
					break;
				}
			}
			if (y == (int64_t)seg_pokazateli.size()) break;
			
			if (sled[nod] == i) dwljina[nod] += 1;
			else                dwljina[nod]  = 1;
						
			otg = std::max(otg, dwljina[nod] * nod);
			
			sled[nod] = i + 1;
		}
	}
	
	return otg;
}

long long max_segment(std::vector<int> a) {
	return max_segment_obxto(a);
}

#ifndef EVAL
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	
	int N;
	std::cin >> N;
	std::vector<int> A(N);
	for(auto &x : A) std::cin >> x;
	std::cout << max_segment(A) << std::endl;
	
	return 0;
}
#endif