#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
struct edge
{
    int ver,dist,t;
    edge(){}
    edge(int _ver,int _dist,int _t)
    {
        ver=_ver;
        dist=_dist;
        t=_t;
    }
    bool operator <(const edge& e)const
    {
        if(e.dist<dist)return 1;
        return 0;
    }
};
const int maxn=2*1e5+2;
int n,m,k;
int used[maxn];
unsigned int d[maxn];
int td[maxn];
unsigned int inf=-1;
vector<edge>v[maxn];
void read()
{
    cin>>n>>m>>k;
    int x,y,t;
    for(int i=1;i<=m;i++)
    {
        cin>>x>>y>>t;
        edge e(y,1,t);
        v[x].push_back(e);
        e.ver=x;
        v[y].push_back(e);
    }
}
void dijkstra(int s)
{
    memset(d,-1,sizeof(d));
    edge e(s,0,1);
    d[s]=0;
    priority_queue<edge>q;
    q.push(e);
    while(!q.empty())
    {
        e=q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            if(!used[e.ver])
            {
                used[e.ver]=1;
                int sz=v[e.ver].size();
                for(int i=0;i<sz;i++)
                {
                    edge nb=v[e.ver][i];
                    if(!used[nb.ver])
                    {
                        if(d[nb.ver]<=d[e.ver]+nb.dist)
                        {
                            /*if(nb.t==2)
                            {
                                if(td[nb.ver])
                            }*/
                            d[nb.ver]=d[e.ver]+nb.dist;
                            nb.dist=d[nb.ver];
                            q.push(nb);
                        }
                    }
                }
            }
        }
    }
}
void solve()
{
    dijkstra(1);
    if(d[n]==inf)cout<<-1<<endl;
    else cout<<d[n]<<endl;
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();

    return 0;
}
