#include <bits/stdc++.h>

using namespace std;
const int maxn=200001;
int n, m, k;
int d[maxn][4];
struct edge
{
    int ver, t;
};
struct _edge
{
    int ver, l, t;
    bool operator<(const _edge& e)const
    {
        if(l<e.l)return false;
        else if(l==e.l&&t<e.t)return false;
        else return true;
    }
};
vector<edge>v[maxn];

void read()
{
    cin>>n>>m>>k;
    int a, b, t;
    for(int i=0;i<m;i++)
    {
        cin>>a>>b>>t;
        v[a].push_back({b,t-1});
        v[b].push_back({a,t-1});
    }
    for(int i=0;i<=n;i++)
    {
        d[i][0]=d[i][1]=d[i][2]=INT_MAX;

    }
}

void dfs_Dijkstra(int beg, int cl, int ck)
{
    if(ck>k)return;
    d[beg][ck]=cl;
    int sz=v[beg].size();
    for(int i=0;i<sz;i++)
    {
        int nbv=v[beg][i].ver;
        int nbt=v[beg][i].t;
        if(d[nbv][ck+nbt]>cl+1)
        {
            dfs_Dijkstra(nbv, cl+1, ck+nbt);
        }
    }
}

void bfs_Dijkstra()
{
    priority_queue<_edge>q;
    _edge w;edge nb;
    _edge s={1,0,0};
    d[1][0]=0;
    q.push(s);
    while(!q.empty())
    {
        w=q.top();
        q.pop();
        if(!(w.l>d[w.ver][w.t]))
        {
            int sz=v[w.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb=v[w.ver][i];
                if(!(w.t+nb.t>k))
                {
                    if(d[nb.ver][w.t+nb.t]>w.l+1)
                    {
                        d[nb.ver][w.t+nb.t]=w.l+1;
                        _edge _nb={nb.ver, w.l+1, w.t+nb.t};
                        q.push(_nb);
                    }
                }
            }
        }
    }
}

void solve()
{
    bfs_Dijkstra();
    int ans=min(d[n][0], min(d[n][1],d[n][2]));
    (ans==INT_MAX)?(ans=-1):(ans=ans);
    cout<<ans<<'\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
