#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;
const int inf = 1e9 + 10;

int n, m, k;
vector < pair < int, int > > adj[maxn];
int dist[3][maxn];
void input()
{
    cin >> n >> m >> k;
    for (int i = 1; i <= m; i ++)
    {
        int v, u, t;
        cin >> v >> u >> t;
        adj[v].push_back({u, t});
        adj[u].push_back({v, t});
    }
}

void bfs()
{
    for (int i = 1; i <= n; i ++)
        for (int j = 0; j <= k; j ++)
        dist[j][i] = inf;

    dist[0][1] = 0;

    queue < pair < int, int > > q;
    q.push({1, 0});

    while(!q.empty())
    {
        pair < int, int > cur = q.front();
        q.pop();
        //cout << "here " << cur.first << " " << cur.second << " " << dist[cur.second][cur.first] << endl;
        for (pair < int, int > nb : adj[cur.first])
        {
            pair < int, int > to = {nb.first, cur.second};
            if (nb.second == 2)
                to.second ++;
                ///cout << "edge " << to.first << " " << to.second << " " << nb.second << endl;
            if (to.second <= k && dist[to.second][to.first] > dist[cur.second][cur.first] + 1)
            {
                q.push(to);
                dist[to.second][to.first] = dist[cur.second][cur.first] + 1;
            }
        }
    }
}
void solve()
{
    input();
    bfs();
    int ans = inf;
    for (int j = 0; j <= k; j ++)
    {
        ///cout << "step " << dist[j][n] << endl;
        ans = min(ans, dist[j][n]);
    }
    if (ans == inf)
        cout << -1 << endl;
    else
        cout << ans << endl;
}

int main()
{

    speed();
    solve();
    return 0;
}
