#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;
int n, m, d, k, deg[maxn];
vector < int > adj[maxn];
int mark[maxn];
void input()
{
    cin >> n >> m >> d >> k;
    for (int i = 1; i <= n; i ++)
    {
         adj[i].clear();
         mark[i] = 0;
    }
    for (int i = 1; i <= m; i ++)
    {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}


void simulate()
{
    int maxs = d / k;

    for (int col = 1; col <= k; col ++)
    {
        for (int i = 1; i <= n; i ++)
        {
            if (mark[i] != 0)
                continue;
            int cnt = 0;
            bool tf = true;
            for (int u : adj[i])
            {
                if (mark[u] != col)
                    continue;
                int s = 0;
                for (int w : adj[u])
                {
                    if (mark[w] == col)
                        s ++;
                }
                //cout << " HERE " << col << " " << i << " " << u << " " << s << endl;
                if (s + 1 > maxs)
                    tf = false;

                    cnt ++;
            }
            //cout << col << " " << i << " " << tf << " " << cnt << endl;
            if (tf && cnt <= maxs)
            {
                mark[i] = col;
            }

        }
    }

    for (int i = 1; i <= n; i ++)
        cout << mark[i] << " ";
    cout << endl;
}
void solve()
{
    input();
    simulate();
}

int main()
{
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
