#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;
int n, m, d, k, deg[maxn];
vector < int > adj[maxn];
int mark[maxn];
void input()
{
    cin >> n >> m >> d >> k;
    for (int i = 1; i <= n; i ++)
    {
        adj[i].clear();
        mark[i] = 0;
    }
    for (int i = 1; i <= m; i ++)
    {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}


int ridx[maxn];
mt19937 rng(time(NULL));

void simulate()
{
    int maxs = d / k;
    while(true)
    {
        for (int i =1; i <= n; i ++)
            mark[i] = 0, ridx[i] = i;

            for (int i = 1; i <= n; i ++)
            {
                int idx = rng() % n + 1;
                swap(ridx[i], ridx[idx]);
            }

        for (int col = 1; col <= k; col ++)
        {
            for (int i = 1; i <= n; i ++)
            {
                int v = ridx[i];
                if (mark[v] != 0)
                    continue;
                int cnt = 0;
                bool tf = true;
                for (int u : adj[v])
                {
                    if (mark[u] != col)
                        continue;
                    int s = 0;
                    for (int w : adj[u])
                    {
                        if (mark[w] == col || w == v)
                            s ++;
                    }
                    //cout << " HERE " << col << " " << i << " " << u << " " << s << endl;
                    if (s > maxs)
                        tf = false;

                    cnt ++;
                }
                //cout << col << " " << i << " " << tf << " " << cnt << endl;
                if (tf && cnt <= maxs)
                {
                    mark[v] = col;
                }

            }
        }

        bool fine = true;
        for (int i = 1; i <= n; i ++)
        {
            if (mark[i] == 0)
            {
                fine = false;
                break;
            }
        }

        if (fine)
            break;
    }
    for (int i = 1; i <= n; i ++)
    {
        ///assert(mark[i] != 0);
        /**int cnt = 0;
        for (int u : adj[i])
            if (mark[u] == mark[i])
            cnt ++;
        assert(cnt <= maxs);*/
        cout << mark[i] << " ";
    }
    cout << endl;
}
void solve()
{
    input();
    simulate();
}

int main()
{
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
