#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_cxx;

struct test
{
    int ver;
    bool typ;
    test(int _x, bool _y)
    {
        ver = _x;
        typ = _y;
    }
};

vector<test> v[10000];
vector<int> ans;
int n, m, k;
int used[10000];

/*
1 - airplane
2 - bus
*/

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> n >> m >> k;
    for(int i = 1; i <= m; i++)
    {
        int x, y, t;
        cin >> x >> y >> t;
        v[x].push_back({y, t == 2 ? 1 : 0});
        v[y].push_back({x, t == 2 ? 1 : 0});
    }
}

void DFS(int x, int sam = 0)
{
    if(sam > k)
    {
        ans.clear();
        return;
    }
    ans.push_back(x);
    used[x] = 1;
    for(int i = 0; i < v[x].size(); i++)
    {
        int ver = v[x][i].ver;
        if(!used[ver])
        {
            if(v[x][i].typ != 1)
            {
                DFS(ver);
            }
            else
            {
                DFS(ver, sam + 1);
            }
        }
    }
}

int main()
{
    speed();
    read();
    DFS(n);
    vector<int> path;

    for(int i = 0; i < ans.size(); i++)
    {
        if(ans[i] == 1)
        {
            path.push_back(1);
            break;
        }
        else path.push_back(ans[i]);
    }
    if(path.size() == 0) cout << -1 << endl;
    else cout << path.size() - 1 << endl;
    return 0;
}

/*
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2

3 2 1
1 2 2
2 3 2
*/
