#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_cxx;

struct test
{
    int ver;
    int typ;
    test(int _x, int _y)
    {
        ver = _x;
        typ = _y;
    }
    test()
    {
        ver = 0;
        typ = -1;
    }
    operator<(test x)
    {
        return x.typ > typ;
    }
};

vector<test> v[10000];
vector<int> path;
vector<int> path_edges;
int n, m, k, used[10000];

/*
1 - airplane
2 - bus
*/

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    cin >> n >> m >> k;
    for(int i = 1; i <= m; i++)
    {
        int x, y, t;
        cin >> x >> y >> t;
        test edge;
        edge.ver = y;
        edge.typ = t;
        v[x].push_back(edge);
    }
}

void Dijkstra(int n)
{
    priority_queue<test> q;
    test edge;
    edge.ver = n;
    edge.typ = -1;
    used[n] = 1;
    q.push(edge);
    while(!q.empty())
    {
        test top = q.top();
        q.pop();
        for(int i = 0; i < v[top.ver].size(); i++)
        {
            test current = v[top.ver][i];
            if(!used[current.ver])
            {
                //if()
                q.push(current);
            }
        }
    }
}

int main()
{
    int cnt = 0;
    speed();
    read();
    Dijkstra(n);
    for(int i = 0; i < path_edges.size(); i++)
    {
        if(path_edges[i] == 2)
        {
            cnt++;
            if(cnt > k)
            {
                cout << -1 << endl;
                return 0;
            }
        }
    }
    cout << path.size() - 1 << endl;
    return 0;
}

/*
5 5 1
1 2 1
2 3 1
3 5 2
2 4 1
4 5 2

3 2 1
1 2 2
2 3 2
*/
