#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#define endl "\n"

//#define __LOCALTEST

#ifdef __LOCALTEST
using namespace std;
using namespace __gnu_cxx;
#else
using std::cin;
using std::cout;
using std::ios_base;
using std::vector;
using std::greater_equal;
using std::max_element;
using std::sort;
#endif

bool isprime(int n)
{
    if(n == 1 || n == 2) return true;
    for(int d = 2; d <= sqrt(n); d++)
    {
        if(n % d == 0) return false;
    }
    return true;
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

long long max_segment(vector<int> A)
{
    speed();
    sort(A.begin(), A.end());
    int prev_pos = 0;
    int cnt1 = 0;
    int cnt_tmp = 0;
    int cnt_tmp2 = 0;

    for(int i = 0; i < A.size(); i++)
    {
        if(A[i] == 1) cnt_tmp++;
        if(A[i] % 2 == 0) cnt_tmp2++;
        if(isprime(A[i])) cnt1++;
    }
    if(cnt1 == A.size() || cnt_tmp + cnt_tmp2 == A.size())
    {
        for(int i = 0; i < A.size() - 1; i++)
        {
            int tmp = std::__gcd(A[i], A[i + 1]);
            if(tmp != 0)
            {
                prev_pos = i;
                break;
            }
        }
#ifdef __LOCALTEST
        cout << prev_pos << endl;
        cout << "---------" << endl;
#endif
        int i = prev_pos;
        long long sum=1;

        while(i != A.size() - 1)
        {
#ifdef __LOCALTEST
            cout << std::__gcd(A[i], A[i + 1]) << endl;
#endif
            sum += std::__gcd(A[i], A[i + 1]);
            i++;
        }
        if(cnt_tmp + cnt_tmp2 == A.size() && cnt1 != A.size())
        {
            return sum-A[prev_pos+1]-2;
        }
        return sum-A[prev_pos+1]+1;
    }
    return A[A.size() - 1];
}
